init python:
    import random    #importing the random function
#============================================================================================== GLOBAL
# ■██▓▒░ GLOBAL functions and constants ░▒▓███████████████████████████████████████████████■
#==============================================================================================

    NO_ELEM = 0
    STONE  =9   #Constants to access plant arrays
    MOUNT  =1
    HARVEST=2
    EARTH  =3
    SWAMP  =4
    RIVER  =5
    AIR    =6
    STORM  =7
    FIRE   =8
    WATER =10

    WEAK   =1
    STRONG =2

    NAME=0
    DEFEATS=0
    LUNGS =1
    GUTS =2

    # Global Functions
    
    def ListAdd(t_num, t_list): #Adds an int to the list
        if not(t_num in t_list):
            t_list.append(t_num)

    def ListSub(t_num, t_list): #Removes an int from the list
        if t_num in t_list:
            t_list.remove(t_num)
            
    def ListAddList(t_newlist, t_list): #Adds a list of int to the list
        for x in t_newlist:
            ListAdd(x, t_list)
            
    def ListHas (t_num, t_list):
        if t_num in t_list:
            return True
        else:
            return False
    
    def StrongStrike (max_damage): # Returns attack damage (int), given (max damage). Range: Minimum damage is half the max damage, rounded up.
                                   # Example: Max=1, damage always 1. Max=2: Damage 1,2. Max=3: Damage 2,3. Max=4: Damage 2,3,4. Max=5: Damage 3,4,5. Max 6: Damage 4,5,6
        half = max_damage/2                             #if max=5, then half=2
        return (random.randrange(half+1) +half)      #random.randrange(3)+2 = (1 to 3) +2 = 3 to 5

    def WeakStrike(max_damage):  # WeakStrike (max_damage):   #Returns attack damage (int), given (max_damage). Range: 1 to max. 
        fifth = max_damage/5                             #if max=5, then fifth =1
        return ((random.randrange(max_damage - fifth)+1) +fifth)  # min damage is 1/5 of max. 

    def getElemName (Elem):      # Given an element label (int), returns a string with the element name, first letter capitalized.
        if Elem == EARTH:        #set the name of the sickness element we're fighting
            return "Earth"
        elif Elem == SWAMP:
            return "Swamp"
        elif Elem == RIVER:
            return "River"
        elif Elem == AIR:
            return "Air"
        elif Elem == STORM:
            return "Storm"
        elif Elem == FIRE:
            return "Fire"
        elif Elem == STONE:
            return "Stone"
        elif Elem == MOUNT:
            return "Mountain"
        elif Elem == HARVEST:
            return "Harvest"
        elif Elem == WATER:
            return "Water"
        else:
            return "ERROR"
    def simplify_elem (Elem):   # Simplifies element choice down to the 4 elements + STORM. Add Stress and Toxin mechanics later
        if Elem == EARTH:        
            return EARTH
        elif Elem == STONE:
            return EARTH
        elif Elem == MOUNT:
            return EARTH
        elif Elem == HARVEST:
            return EARTH
            
        elif Elem == SWAMP:
            return WATER
        elif Elem == RIVER:
            return WATER
        elif Elem == AIR:
            return AIR
        elif Elem == STORM:
            return STORM
        elif Elem == FIRE:
            return FIRE
        else:
            return 0


    def getPartName (part):      # Given a part label (int), returns a string with the part name, first letter capitalized.
        if part == LUNGS:        #set the organ targeted by the sickness element we're fighting
            return "Lungs"
        elif part == GUTS:
            return "Guts"
        else:
            return "ERROR"
            
    def elemCanDefeat(chosenElem, sickElem):
        if (chosenElem== FIRE and sickElem == EARTH):              #if an element is specified, check if that one works, rather than just 
            return True
        elif (chosenElem== EARTH and sickElem == FIRE):             
            return True
        elif (chosenElem== AIR and sickElem == RIVER):             
            return True
        else:
            return False
            
    def vulnerable_to (disease, chosenElem):
        sickElem = disease.element
        if (chosenElem== FIRE and sickElem == EARTH):              #if an element is specified, check if that one works, rather than just 
            return True
        elif ((chosenElem== EARTH or chosenElem== STONE) and sickElem == FIRE):             
            return True
        elif (chosenElem== AIR and sickElem == RIVER):             
            return True
        elif (chosenElem== STORM and sickElem == SWAMP):             
            return True
        elif ((chosenElem== SWAMP or chosenElem== RIVER) and sickElem == AIR):             
            return True
        elif (chosenElem== MOUNT and sickElem == STORM):             
            return True
        else:
            return False

    def one_plant_active(Ateam, maxteam):               # Returns True if at least one Plant's active flag is True
        for i in range (1,maxteam+1):
            if Ateam[i].active == True:
                #renpy.say(None,(Ateam[i].name+" is active, slot "+str(i)))
                return True
        return False

    def popupR (actor,descript,result=0,sign=""): # Calls one of multiple ally status screens so they don't overlap. 
        for i in range(1,5):
            if renpy.get_screen("popup_plant1", layer='screens')== None:
                renpy.show_screen("popup_plant1", actor, result, descript, sign)
                return
            elif renpy.get_screen("popup_plant2", layer='screens')== None:
                renpy.show_screen("popup_plant2", actor, result, descript, sign)
                return
            elif renpy.get_screen("popup_plant3", layer='screens')== None:
                renpy.show_screen("popup_plant3", actor, result, descript, sign)
                return
            else: 
                renpy.pause(delay=1.0)          #if all three screens are showing, wait a second then try again. Max 5 tries
                
    def wait_for_popupR():                      # Wait for Right popups to be gone, max 5 seconds
        for i in range(1,4):
            if (renpy.get_screen("popup_plant1")== None and renpy.get_screen("popup_plant2")== None and renpy.get_screen("popup_plant1")== None):
                return
            else:
                renpy.pause(delay=1.0)          #if all friendstat screens are showing, wait a second then try again. Max 5 tries

    def wait_for_popupL():                      # Wait for Left popups to be gone, max 5 seconds
        for i in range(1,4):
            if (renpy.get_screen("sickstat_change")== None and renpy.get_screen("clientstat_change")== None):
                return
            else:
                renpy.pause(delay=1.0)          #if all foestat screens are showing, wait a second then try again. Max 5 tries

                
    def deactivateP(allyN, Ateam):  # Deactivate current ally. Return index of still active ally, or 0 if none
        if allyN == 1:                          # Just used Ally 1
            Ateam[1].active = False             # Turn off Ally 1
            if Ateam[2].active == True:         # If Ally 2 still fresh
                return 2                        # return 2 as current ally
            else:
                return 0                        # Return 0 if both are spent
                
        if allyN == 2:                          # Just used Ally 2
            Ateam[2].active = False             # Turn off Ally 2
            if Ateam[1].active == True:         # If Ally 1 still fresh
                return 1                        # return 1 as current ally
            else:
                return 0                        # Return 0 if both are spent
        
       # elemChoice = 0
       # playerAction = 0
       # allyN = 0
       # Ateam[allyN].active = False        
        
#============================================================================================== VILLAGER
# ■██▓▒░ VILLAGER class ░▒▓█████████████████████████████████████████████████████████████████████■
#==============================================================================================
    class Villager (object):
        """ Villager's stats """
        
        total = 0           # CLASS VARIABLE. Not attached to any member object. This variable spans the class and counts total number of villagers
        MAX_ELEM = 1000     # Class constant, maximum value of an elemental attribute
        NORM_ELEM = MAX_ELEM/2
        MAX_VITAL = 1000
        BASE_ELEM = 0
        
        def status():
            return Villager.total  #The total number of villagers, also accessed by Villager.total inside and outside the class
        status = staticmethod(status)   #static methods are only accessible with the class. 

        #----------------------------- ### Class constructor ###
        def __init__ (self, name="Stranger", age=20, bio="you have not met before",
                      vitality=MAX_VITAL, max_vitality=MAX_VITAL, air=BASE_ELEM, fire=BASE_ELEM, water=BASE_ELEM, earth=BASE_ELEM,
                      toxic=NORM_ELEM, stress=NORM_ELEM, uterus=False,
                      immune=5, selfheal=5, slow=0, spiritSkill =30):
        #-----------------------------
            Villager.total += 1   #Increment number of villagers of this class
            self.name = name
            self.age = age
            self.bio = bio
            self.vitality = vitality
            self.max_vitality = max_vitality
            self.air = air
            self.fire = fire
            self.water = water
            self.earth = earth
            self.stress = stress
            self.toxic = toxic
            self.uterus = uterus
            self.immune = immune        # 0-9 how strongly immune system fights disease spread
            self.selfheal = selfheal    # 0-9 how much vitality villager can heal in one turn
            self.slow = slow            # 0-9 how many days after incubation before immunity kicks in.
            self.spiritSkill = spiritSkill
            
            self.lastchange = 0         # Extra attribute, the last change made to an attribute is good to know, and used in the actiontext variable below.
            self.actiontext = ""        # Given value by each stat function's call to setActionText(), the actual change
            self.NewValueA = 0          # When checking max/min boundaries, these variables are given adjusted values by boundariesCheck()
            self.NewValueB = 0

        def __str__ (self):         # special class method, allows printing of the object itself: returns name, age and bio in a string
            return self.name+" is "+str(self.age)+" years old, "+self.bio+"."
        def __del__ (self):         # special class method to destroy an object. Returns: name has died
            Villager.total -= 1     #Decrement number of villagers of this class
            return self.name+" has died."
        def reset(self):            # Resets default numeric values.
            self.vitality = self.max_vitality
            self.air = Villager.NORM_ELEM
            self.fire = Villager.NORM_ELEM
            self.water = Villager.NORM_ELEM
            self.earth = Villager.NORM_ELEM
            self.stress = Villager.NORM_ELEM
            self.toxic = Villager.NORM_ELEM
            self.lastchange = 0     # Keep available the actual amount of change in attributes, which adjusts near a limit
            self.actiontext = ""    # This is needed to display damage, elemental changes, stress/toxic changes as they ACTUALLY occurred.
            
        def ageWeaken(self, age=20): # Returns percent value 0-100. Reduces vitality below age 14 and above age 30. 
            self.age = age
            if age < 14:
                percent = (5 * age) + 30   # 30 at age zero, 100 at age 14.
            elif age >30:                        # 100 at age 30, then lose 1 point per year.
                percent = 130 - age        # less than age -30 or more than 130 will give negative vitality. Ghost!
            else:
                percent =100
            self.vitality = int((self.vitality * percent) /100)
            return percent
                
        def setActionText(self, attribute="",stat=0): # sets self.actiontext to description of last action's results. Needs attribute name string.
            if self.lastchange > 0:                      # Flavor text to display
                self.actiontext = self.name+" "+attribute+" +"+str(self.lastchange)+"\n" #  +"\n("+str(stat - self.lastchange)+" to "+str(stat)+")\n"
                return self.actiontext
            elif self.lastchange == 0:
                self.actiontext = self.name+" "+attribute+" is still "+str(stat)+"\n"
                return self.actiontext
            else:
                self.actiontext = self.name+" "+attribute+" -"+str(abs(self.lastchange))+"\n"  #+"\n("+str(stat-self.lastchange)+" to "+str(stat)+")\n"
                return self.actiontext
                
        def getActionText(self):        # Returns description of the last action, then clears it
            temp = self.actiontext
            #self.actiontext = ""         
            return temp

        # ---------------- Single stats section ---------------------------------------------------------------------
        def boundariesCheckSingle(self, a, change=0, maxi=MAX_ELEM): # Set self.NewValueA within 0 to maxi. 
            self.lastchange = change     # Keep available the actual amount of the change, which adjusts near a limit
            if a > maxi :                # Make sure it's not above maxi or below 0
                self.lastchange = self.lastchange - (a -maxi)
                self.NewValueA = maxi
            elif a < 0 :
                self.lastchange = self.lastchange - a  #Requested change, minus the excess below zero (change value has to be negative to get here)
                self.NewValueA = 0
            else :                       # The change is within bounds, so new values are unchanged
                self.NewValueA = a          

        def stressStat(self,change=0):  # Returns value of property. Adds (change) to stress (boundary checking)
            self.stress += change       # Add the positive or negative change
            self.boundariesCheckSingle(self.stress, change)# Make sure it doesn't go above max or below 0
            self.stress = self.NewValueA                                      # Change to what boundary check adjusted it
            self.setActionText("stress", self.stress) # name of changed attribute and its value, to make the display string
            return self.stress          # Return the new value, in case anyone cares

        def toxicStat(self,change=0):   # Returns value of property. Adds (change) to toxic (boundary checking)
            self.toxic += change        # Add the positive or negative change
            self.boundariesCheckSingle(self.toxic, change)# Make sure it doesn't go above max or below 0
            self.toxic = self.NewValueA                                      # Change to what boundary check adjusted it
            self.setActionText("toxicity", self.toxic)                       # Name of changed attribute and its value, to make the display string
            return self.toxic           # Return the new value, in case anyone cares

        def vitalStat(self,change=0):           # Returns value of property. Adds (change) to vitality (with boundary checking 0-max_vitality)
            self.vitality += change                                             # Add the positive or negative change
            self.boundariesCheckSingle(self.vitality, change, self.max_vitality)# Make sure it doesn't go above max or below 0
            self.vitality = self.NewValueA                                      # Change to what boundary check adjusted it
            self.setActionText("vitality", self.vitality)                       # Name of changed attribute and its value, to make the display string
            return self.vitality                                                # Return the new value, in case anyone cares

        #---------- Four elements section ------------------------------------------------------------------------------
        def setDualActionText(self, attribute="",attribute2="",stat=0, stat2=0): # sets self.actiontext to description of last action's results. Needs attribute name string.
            if self.lastchange > 0:                      # Flavor text to display
                self.actiontext = "+"+str(self.lastchange)+" boost to "+attribute+"\n"+attribute2+" drops to "+str(stat2)+". "
                return self.actiontext
            elif self.lastchange == 0:
                self.actiontext = self.name+"\'s "+attribute+" is still "+str(stat)+". \n"
                return self.actiontext
            else:
                self.actiontext = "-"+str(self.lastchange)+" to "+attribute+"\n"+attribute2+" rises to "+str(stat2)+". "
                #self.name+"\'s "+attribute+" drops by "+str(abs(self.lastchange))+" (from "+str(stat-self.lastchange)+" to "+str(stat)+")\n"+attribute2+" rises to "+str(stat2)
                return self.actiontext


        def boundariesCheck(self, a, b=0, change=0, maxi=MAX_ELEM):  # Set self.NewValueA and .B within 0 to maxi. 
            self.lastchange = change     # Keep available the actual amount of the change, which adjusts near a limit
            if (a > maxi) or (b < -maxi):         # Make sure it's not above 200 or below 0 
                self.lastchange = self.lastchange - (a -maxi)
                self.NewValueA = maxi
                self.NewValueB= 0
            elif (a < -maxi) or (b > maxi):
                self.lastchange = self.lastchange - a  #Requested change, minus the excess below zero (change value has to be negative to get here)
                self.NewValueA = 0
                self.NewValueB= maxi
            else :                          # The change is within bounds, so new values are unchanged
                self.NewValueA = a          
                self.NewValueB = b          # As Fire increases, Earth decreases and vice versa.

        def fireStat(self,change=0):    # Returns value of property. Adds (change) to fire, subtracts it from earth (boundary checking)
            self.fire += change         # Add the positive or negative change
            self.earth -=change
            self.boundariesCheck(self.fire, self.earth, change, Villager.MAX_ELEM)  # puts corrected values in self.NewValueA and self.NewValueB
            self.fire = self.NewValueA
            self.earth = self.NewValueB       
            self.setDualActionText("Fire", "Earth",self.fire,self.earth)            # name of changed attributes and their values, to make the display string
            return self.fire            # Return the new value, in case anyone cares

        def earthStat(self,change=0):   # Returns value of property. Adds (change) to earth, subtracts it from fire (boundary checking)
            self.earth += change        # Add the positive or negative change
            self.fire -= change
            self.boundariesCheck(self.earth, self.fire, change, Villager.MAX_ELEM) # puts corrected values in self.NewValueA and self.NewValueB
            self.earth = self.NewValueA       
            self.fire = self.NewValueB
            self.setDualActionText("Earth","Fire",self.earth,self.fire)            # name of changed attributes and their values, to make the display string
            return self.earth           # Return the new value, in case anyone cares

        def airStat(self,change=0):    # Returns value of property. Adds (change) to air, subtracts it from water (boundary checking)
            self.air += change         # Add the positive or negative change
            self.water -= change 
            self.boundariesCheck(self.air, self.water, change, Villager.MAX_ELEM) # puts corrected values in self.NewValueA and self.NewValueB
            self.air = self.NewValueA       
            self.water = self.NewValueB
            self.setDualActionText("Air","Water",self.air,self.water)            # name of changed attributes and their values, to make the display string        self.setActionText("air", self.air) # name of changed attribute and its value, to make the display string
            return self.air            # Return the new value, in case anyone cares

        def waterStat(self,change=0):   # Returns value of property. Adds (change) to water, subtracts it from air (boundary checking)
            self.water += change        # Add the positive or negative change
            self.air -= change 
            self.boundariesCheck(self.water, self.air, change, Villager.MAX_ELEM) # puts corrected values in self.NewValueA and self.NewValueB
            self.water = self.NewValueA       
            self.air = self.NewValueB
            self.setDualActionText("Water","Air",self.water,self.air)            # name of changed attributes and their values, to make the display string
            return self.water           # Return the new value, in case anyone cares

        def earthImbalance (self): #Returns immunity bonus (int). Range: 0 to max_bonus. Based on fire and water balance
        #-----------------------------------------           #When the Villager's elements are balanced, immune response is increased, giving a healing bonus up to t_max. 
            temp = self.earth           #Returns percentage of effectiveness of Earth diseases
            if temp > 200:
                return 200
            elif temp < 1:
                return 0
            else:
                return temp


        ## ===========================UNTESTED BELOW =======================================

        def balanceBonus (self, max_bonus=5): #Returns immunity bonus (int). Range: 0 to max_bonus. Based on fire and water balance
        #-----------------------------------------           #When the Villager's elements are balanced, immune response is increased, giving a healing bonus up to t_max. 
            drift = abs(self.fire-NORM_ELEM) +abs(self.water-NORM_ELEM)  #How far are they from balance? Total of distance from 100 for both fire and water
            if drift > max_bonus:
                return 0
            else:
                return max_bonus - drift
                
        def holyBonus (self, sliceS=10, max_bonus=5): #Returns immunity bonus (int), based on Stress and Toxicity. +1 per slice
        #-------------------------------------------  #If villager toxicity is below 100 (pure) or stress below 100 (zen) they have better immunity
            bonus = 0                                 #If nothing applies, bonus will be zero
            calm = 20-(self.stress/sliceS)

            if self.stress < NORM_ELEM:
                bonus = bonus + sliceS-(self.stress/sliceS)-1  # 1 point bonus starts at -11
            if self.toxic < NORM_ELEM:  
                bonus = bonus + sliceS -(self.toxic/sliceS)-1  #Pure bonus
            if bonus > max_bonus:
                return max_bonus                         #If greater than max_bonus, return max_bonus
            else:
                return bonus

        def doSleep(self, hours):   # Reduces fire (-20) earth(-10), increases vitality by 5xhours
            self.fire -= 20         # unbalanced change, directly changing stats
            self.earth -=10
            vitalStat(int(hours*5)) # Restores 5 vitality per hour, 8h is +40 vitality

        def doEat(self):            # An hour to prepare and eat food
            self.fire += 10         # unbalanced change, directly changing stats
            self.earth += 20
            vitalStat(+10)          # Restores 10 vitality. 
            #also reduces spiritSkill for 2h, climbing from -40 to 0, 5 points every 15 min. 

        def doDrink(self, change=10):   # increases water. 15 min going to well for water, filling water jug
            waterStat(+change)
            
        def doExercise(self, change=10):        # 15 min exercise: increases fire by change, reduces water by change
            fireStat(+change)                   # Balanced change, -10 Earth, +10 Fire.
            waterStat(-change)

        def doMeditate(self, change=-5):        # 15 min, reduces stress. 
            stressStat(change)        


        def fightSpread (self):
            print "ow"




#============================================================================================== PLANT
# ■██▓▒░ PLANT class ░▒▓█████████████████████████████████████████████████████████████████████■
#============================================================================================== 
    class Plant (object):
        """ Plant's stats """
        total = 0           # This variable spans the class and counts total number of plants
        def status():
            return Plant.total  #The total number of plants, also accessed by Plants.total inside and outside the class
        status = staticmethod(status)

        def __init__ (self, name="Placebonita", sickPart=LUNGS):  ### Class constructor ###
        #-----------------------------
            Plant.total += 1  #increment number of villagers of this class
            self.name = name
            self.sickPart = sickPart
            self.part = 0
            self.element = 0
            self.active = False         # During combat, only one plant can be selected to be active. 

            # Define: sickElemName, partElemName, txt, elem(array), stopspread, rightpart
            #self.sickElemName = getElemName(sickElem) #set the name of the sickness element we're fighting
            self.sickPartName = getPartName(sickPart) #set the organ targeted by the sickness element we're fighting

            if self.name == "Angelica":
                self.txt = ("Angelica archangelica","Fire:9, Harvest:4, Swamp:3", "I bring heavenly fire to the cold and the weak.")
                self.img = "sprite/iAngelica_"  # "sprite/iAngelica_%s.png"
                self.unlocked = True
                self.index =1
                self.elem = ({EARTH:9, AIR:3, WEAK:3},                          # DEFEATS : useful for these conditions
                             {FIRE:9, SWAMP:3, HARVEST:4},                      # LUNGS: elemental powers
                             {FIRE:6, SWAMP:9, HARVEST:6})                      # GUTS: elemental powers #print "Angelica defeats earth:", self.elem[DEFEATS][EARTH]

            elif self.name == "Elder":
                self.txt = ("Sambucus nigra","Earth:9, Mountain:8, Stone:7,\nFire:5, River:3", "Down the dark road, I pull poisons from your sky.")  # TXT :
                self.img = "sprite/iElder_"
                self.unlocked = True
                self.index =2
                self.elem = ({STORM:8, FIRE:9, EARTH:5, AIR:3},                 # DEFEATS : useful for these conditions
                             {MOUNT:7, EARTH:9, FIRE:5, RIVER:3, STONE:8},      # LUNGS: elemental powers
                             {})                                                # GUTS: elemental powers

            elif self.name == "Elecampane":
                self.txt = ("Inula heminum", "Mountain:9, Fire:8, Storm:7,\nAir:5","Elf-shot I mend, and serve with honor." )
                self.img = "sprite/iElecampane_"
                self.unlocked = True
                self.index =3
                self.elem = ({EARTH:8,STORM:9,RIVER:5,SWAMP:7},                 # DEFEATS : useful for these conditions
                             {FIRE:8,MOUNT:9,AIR:5,STORM:7},                    # LUNGS: elemental powers
                             {})                                                # GUTS: elemental powers

            elif self.name == "Panacea":
                self.txt = ("Panaceum Unobtainium", "Panacea has all the powers,\nat rating 1","Cure all... slowly")  # TXT :
                self.unlocked = True
                self.img = "sprite/sprite_none_"
                self.index =4
                self.elem = ({FIRE:1,EARTH:1,SWAMP:1,RIVER:1,AIR:1,STORM:1},   # DEFEATS : useful for these conditions
                             {FIRE:1,EARTH:1,STONE:1,MOUNT:1,HARVEST:1,SWAMP:1,RIVER:1,AIR:1,STORM:1},  # LUNGS: elemental powers
                             {FIRE:1,EARTH:1,STONE:1,MOUNT:1,HARVEST:1,SWAMP:1,RIVER:1,AIR:1,STORM:1})                                            # GUTS: elemental powers
                self.img = "sprite_panacea"
                
            else:
                self.txt = ("Brutus Placebo","Placebo has no powers.", "Unless you believe hard enough...")  # TXT :
                self.img = "sprite/sprite_none_"
                self.unlocked = True
                self.index =0
                self.elem = ({},   # DEFEATS : useful for these conditions
                             {},  # LUNGS: elemental powers
                             {})                                            # GUTS: elemental powers




        def canDefeat(self, sickElem):
            if self.sickElem in self.elem[DEFEATS]:
                return True
            else:
                return False
            
                #self.stopspread = self.elem[DEFEATS][sickElem]
                #print self.name,"defeats",self.sickElemName,"with power", self.stopspread
            
        def hasPower(self, t_elem, t_part=LUNGS ): # Returns true if this is an elemental power of the plant for this part
            if t_elem in self.elem[t_part]: # usage: if Angel.hasPower(SWAMP):
                return True
            else:
                return False


#============================================================================================== DISEASE
# ■██▓▒░ DISEASE class ░▒▓█████████████████████████████████████████████████████████████████████■
#============================================================================================== 
    class Disease (object):
        """ Disease's stats """
        total = 0           # CLASS VARIABLE. Not attached to any member object. This variable spans the class and counts total number of villagers

        def status():       #The total number of instances of this class, also accessed by Disease.total inside and outside the class
            return Disease.total
        status = staticmethod(status)   #static methods are only accessible with the class. 

        def __init__ (self, name="Disease", bio="a sickening",   ### Class constructor ###
                      target="Lungs", element=SWAMP, elemtwo=SWAMP, elem_sway = 1, virulence = 50, spread = 0, max_spread =1000, attack =50, effect =0):
            Disease.total += 1   #Increment number of instances of this class
            self.name = name
            self.bio = bio
            self.target = target            # Target organ or system
            self.element = element          # which elemental excess this disease is based on.
            self.elemtwo = elemtwo          # The chronic elemental condition underlying the acute one
            self.elem_sway = elem_sway      # Max points it can enhance elemental excess each turn
            self.virulence = virulence      # By what % it can spread through the organ each turn.
            self.spread = spread            # How far it has spread
            self.max_spread = max_spread    # Maximum allowed spread
            self.attack = attack            # Max damage to vitality each turn
            self.effect = effect
            
            self.lastchange = 0     # Extra attribute, the last change made to an attribute is good to know.
            self.actiontext = ""
            self.change = 0         # is same as lastchange on first lookup of getActionText(), and zero afterward. So that status change announcements distinguish new changes from old changes. 
            self.dead = False       # This is a flag that is set when the disease is defeated. 

        def __str__ (self):         # special class method, allows printing of the object itself
            return self.name+" is "+str(self.bio)+"."
        def __del__ (self):         # special class method to destroy an object
            Disease.total -= 1     #Decrement number of instances of this class
            return self.name+" has been defeated."

        def reset(self):            # Resets default numeric values.
            self.lastchange = 0     # Keep available the actual amount of change in attributes, which adjusts near a limit
                                    # This is needed to display damage, elemental changes, stress/toxic changes as they ACTUALLY occurred.
                                    
        def setActionText(self, attribute="spread", stat= 0): # sets self.actiontext to description of last action's results. Needs attribute name string.
            if (self.change > 0):                      # Flavor text to display
                self.actiontext = self.name+" "+attribute+" +"+str(self.lastchange)+"\n"   #+"\n(from "+str(stat - self.lastchange)+" to "+str(stat)+")"
                #print "ah oy"
            elif self.change == 0:
                self.actiontext = self.name+" "+attribute+" is still ** "+str(stat)+"\n"
                #print "ah ve"
            else:
                self.actiontext = self.name+" "+attribute+" -"+str(abs(self.lastchange))+"\n"  #+"\n(from "+str(stat-self.lastchange)+" to "+str(stat)+")"
                #print "ah shmuck"
            #return self.actiontext
                
#        def getActionText(self):        # Returns description of the last action, then clears it
#            #temp = self.actiontext
#            #self.actiontext = ""
#            temp = self.actiontext
#            #self.change = 0
#            return temp          
        
        
        
        
        def spreadStat(self,change=0):           # Returns value of property, changes to new value if specified
            self.spread += change                                               # Add the positive or negative change
            if self.spread > self.max_spread:                                   # Make sure it doesn't go above max or below 0
                self.lastchange =  self.max_spread - self.spread
                self.spread = self.max_spread
                self.change = self.lastchange
                self.actiontext = self.name+"\'s "+attribute+" increases by "+str(self.lastchange)+" (from "+str(stat - self.lastchange)+" to "+str(stat)+")"
            elif self.spread < 1:
                self.lastchange = change - self.spread  #We'll consider overkill bonuses later...
                self.spread = 0                         #Disease is dead! Raise a flag!
                self.dead = True
                self.change = self.lastchange
                self.actiontext = "Disease defeated!"
            else:
                self.lastchange = change                # Checking if spread below zero done outside the class
                self.change = change
            self.setActionText("spread", self.spread)                       # Name of changed attribute and its value, to make the display string


#        def targetStat(self,change=0):           # Returns value of property, changes to new value if specified
#            if change:
#                self.target = change
#            return self.target
#        def elementStat(self,change=0):           # Returns value of property, changes to new value if specified
#            if change:
#                self.element = change
#            return self.element
#        def virulenceStat(self,change=0):           # Returns value of property, changes to new value if specified
#            if change:
#                self.virulence = change
#            return self.virulence
#        def attackStat(self,change=0):           # Returns value of property, changes to new value if specified
#            if change:
#                self.attack = change
##            return self.attack    
##        def max_spreadStat(self,change=0):           # Returns value of property, changes to new value if specified
##            if change:
##                self.max_spread = change
##            return self.max_spread    
##        def elem_swayStat(self,change=0):           # Returns value of property, changes to new value if specified
##            if change:
##                self.elem_sway = change
##            return self.elem_sway    

    def test():
        result = renpy.show_screen("bigChoice","Choose Your Team For This Battle")
        while result != "y" and result != "n":
            x=1


    # ■██▓▒░ TEAM SELECTION ░▒▓██████████████████████████████████████████████████████████████████████████████████████■
    def team_selection(Ateam,Pteam):
        
                #renpy.hide_screen("say")
                #ui.callsinnewcontext("_hide_windows")                 # hide the bottom dialog window
        renpy.call_screen("bigMessage","Choose Your Team For This Battle","     Your spiritual power is only sufficient to sustain two\nallies at first.\n", "     Win battles to unlock more slots for your team\nand more allies to choose from.")
                #renpy.show_screen("say")   #window show 
                #renpy.say(None, "clear [Ateam[0].name] [Ateam[1].name] [Ateam[2].name]")
        
        
        slot_unlocked = [True,True,False]          # Only the first two slots are open at first ############ CHANGE THIS #################
        Ateam = [noPowers,noPowers,noPowers]      # Start with empty roster, showing the None icons
        p_angelica.active = True                  # Set each plant to active. Active means they have not yet been added to the roster
        p_elder.active = True                     # Though this changes nothing to whether they are locked or not. Put in FUNCTION
        p_elecampane.active = True
        Pteam = [noPowers,p_angelica, p_elder, p_elecampane] # Potential Team / Plant Team: List of all plants in the game

        ally = noPowers                           # Selected ally starts with None
        
        clear_Ateam = False                       # Set all action flags to False
        add_Ateam = False
        start_battle = False
        answer = ""
        overfull = False
                # renpy.say(None, "clear")
        renpy.show_screen("choose_team")
        renpy.show_screen("roster_screen")
        renpy.show_screen("plant_info_screen")

                #renpy.show_screen("say")   #window show                 # show the bottom dialog window
        renpy.say(None,"Instructions: \n1) Click on a plant ally on the right,\n2) Click Add on the bottom left. Repeat 1 & 2 until your roster is full.\nWhen you're done, click Start Battle on the bottom left.\nClick on the screen to hide these instructions.")
                #ui.callsinnewcontext("_hide_windows")                # hide the bottom dialog window
      
      
      
        #return   ################################################################################### REMOVE THIS RETURN 

        while (start_battle == False):
            # ■██▓▒░ CLEAR ROSTER ░▒▓████████████████████████████████████■
            #renpy.say(None, "clear")
            
            #start_battle = renpy.call_screen("battle_button")
            renpy.pause(1) # ui.interact()
            if clear_Ateam:
                teamselect_clear(clear_Ateam, Ateam, Pteam) #Clears all and returns False, clearing the flag in one shot
                clear_Ateam 
                allyN = 0             # Clear index of currently selected plant
                ally = noPowers       # Clear redsquare selection on right side of menu. 

            # ■██▓▒░ ADD to ROSTER ░▒▓████████████████████████████████████■
         
            if (add_Ateam == True):             # Player has clicked on ADD. Add "ally" to the roster, if add_ally has been set to "ally"
                overfull = teamselect_add (add_Ateam, Ateam, Pteam, allyN, slot_unlocked) # returns True if trying to add while roster is full
                add_Ateam = False             # Clear Add flag after handling event
                allyN = 0                     # Clear ally, otherwise clicking add again will add it a second time, even if it's greyed.

               # "M Ateam [Ateam[0].name] [Ateam[1].name] [Ateam[2].name] add_Ateam [add_Ateam]"
               # "M Pteam [Pteam[1].name] [Pteam[2].name] [Pteam[3].name] allyN [allyN]"

            if overfull:                         # Adding when roster is full
                add_Ateam = False
                start_battle = roster_full(add_Ateam) # Ask player if they want to battle now or return to selection. Sets start_battle flag to True/False
                overfull = False                      # Clear flag so we don't loop back here
                allyN = 0                             # Clear index of currently selected plant
                ally = noPowers                       # Clear redsquare selection on right side of menu. 
            if start_battle:
                break
            Pause(2)
        
            # ■██▓▒░ START BATTLE ░▒▓████████████████████████████████████■
            #if (start_battle):                                                          # When start_battle becomes true, jump to the battle's prep
        renpy.hide_screen("choose_team")                                                 # Hide all the screens
        renpy.hide_screen("roster_screen")
        renpy.hide_screen("plant_info_screen")
        renpy.call_screen("bigMessage","Ready yourself, the battle is about to begin.") # Give clear status message, click on Continue
        return (Ateam)
        
        
                # renpy.jump("prep")                                                               # Go to prep and then battle
            #else:
            #    repeat                              ########################################################LOOPING###################
            #    #pause 2                              # (Only loop once per two seconds)  ##CHANGE##
                #jump team_selection_loop            # Keep Looping otherwise


        # ■██▓▒░ CLEAR ROSTER ░▒▓████████████████████████████████████■

    def teamselect_clear (clear_Ateam, Ateam, Pteam):
        if (clear_Ateam == True):           # Player has clicked button to clear the current Active Team roster
           # renpy.say(None, "clear [Ateam[0].name] [Ateam[1].name] [Ateam[2].name]")
           # renpy.say(None, "activate [Pteam[1].name] [Pteam[2].name] [Pteam[3].name]")


#[SetVariable("Ateam[0]",noPowers),SetVariable("Ateam[2]",noPowers),SetVariable("Ateam[2]",noPowers),
#    SetVariable("Pteam[1].active",True),SetVariable("Pteam[2].active",True),SetVariable("Pteam[3].active",True)]
            Ateam[0] = Pteam[0]      # Active Team is a list(array) of class Plant, noPowers is a member of class Plant with no powers.                  
            Ateam[1] = Pteam[0]          
            Ateam[2] = Pteam[0] 
            Pteam[0].active = True    # Set each Potential Team plant to active. Active means they are not in the roster and can be added

            Pteam[1].active = True    # Set each Potential Team plant to active. Active means they are not in the roster and can be added
            Pteam[2].active = True    # Though this changes nothing to whether they are locked or not.
            Pteam[3].active = True
            clear_Ateam = False
            return False

    def teamselect_clear2 (clear_Ateam, Ateam, Pteam):
        if (clear_Ateam == True):           # Player has clicked button to clear the current Active Team roster
           # renpy.say(None, "clear [Ateam[0].name] [Ateam[1].name] [Ateam[2].name]")
           # renpy.say(None, "activate [Pteam[1].name] [Pteam[2].name] [Pteam[3].name]")

            Ateam[0] = Pteam[0]      # Active Team is a list(array) of class Plant, noPowers is a member of class Plant with no powers.                  
            Ateam[1] = Pteam[0]          
            Ateam[2] = Pteam[0] 
            Pteam[0].active = True    # Set each Potential Team plant to active. Active means they are not in the roster and can be added

            Pteam[1].active = True    # Set each Potential Team plant to active. Active means they are not in the roster and can be added
            Pteam[2].active = True    # Though this changes nothing to whether they are locked or not.
            Pteam[3].active = True
            clear_Ateam = False
            return Ateam
           

            
    # ■██▓▒░ ADD to ROSTER ░▒▓████████████████████████████████████■            
    
    def teamselect_add (add_Ateam, Ateam, Pteam, allyN, slot_unlocked): # returns True if trying to add while roster is full
        # noPowers = Pteam[0]   # points to the null plant
        t_overfull = False
        #======================================= CHECK FOR DUPLICATES
        if in_team (Pteam[allyN], Ateam):       # If the Potential Team ally selected for Add is already in Active Team, do nothing and return immediately. 
            return (False)
        #======================================= ADD IF POSSIBLE    
        if (Ateam[1] == noPowers):          # First slot is empty, put the ally there
            Ateam[1] = Pteam[allyN]         # Set first of Active Team to selection. Setting to default null ally changes nothing. 
            Pteam[allyN].active = False     # Grays out the plant so it can't be added twice

        elif (Ateam[2] == noPowers):    # First was full. If second slot is empty, put the ally there.
            if (slot_unlocked[1]):          # But only if that slot is unlocked. Otherwise tell them roster is full
                Ateam[2] = Pteam[allyN]
                Pteam[allyN].active = False # Grays out the plant so it can't be added twice
            else:
                t_overfull = True                # Trying to add while roster full
            
        elif (Ateam[3] == noPowers):    # second slot is empty, put the ally there.
            if (slot_unlocked[2]):          # But only if that slot is unlocked. Otherwise tell them roster is full
                Ateam[3] = Pteam[allyN] 
                Pteam[allyN].active = False        # Grays out the plant so it can't be added twice
            else:
                t_overfull = True                # Trying to add while roster full
            
        else:                           # trying to add while All SLOTS FULL, tell them so by returning True
            t_overfull = True                # Trying to add while roster full
            
        #======================================= RETURN TRUE IF OVERFULL
        if t_overfull:
            return (True)
        else:
            return (False)
            
                    #call screen bigChoice("Please click on a plant to select it,\then click Add to add it to your roster.")
                    #        renpy.say(None, "Hello 0")

    def roster_full(add_Ateam):                      # Dialog called by team_selection_loop when trying to add more to a full roster
        renpy.hide_screen("plant_info_screen")
        answer = renpy.call_screen("bigChoice","Your roster is full", "Would you like to start the battle now? Click yes to battle.", "Click 'No' to continue choosing your team. Then use the Clear button in the bottom left to select a different team.")
        # pause 1                             # only check every second
        #answer = _return                  # Use returned value. If yes, set start_battle to True
        if answer == "y": 
            return (True)
        elif answer == "n":
            renpy.show_screen("plant_info_screen")
            return (False)

    def in_team (ally, Ateam):   # If ally is in Ateam, return True, otherwise False
        if (Ateam[0] == ally) or (Ateam[1] == ally) or (Ateam[2] == ally):
            return (True)
        else:
            return (False)
