init python:
    
    
    ### CLIMATE_TEXT (FIRESTAT, WATERSTAT) public function. 
    def climate_text (fire, water):     # Supplied fire and water stats, returns a string description. 
        ftext = fire_climate(fire)              #First get the descriptor word for temperature and moisture. 
        wtext = water_climate(water)
        if ftext == "":                 # Temperate temperature
            if wtext == "":                     # Temperate moisture
                return "Temperate"   # Both are balanced
            else:
                return wtext                    # Only give moisture text, temperature is normal.
        elif wtext == "":               # Abnormal temperature, normal moisture
            return ftext                        # Only give temperature text, moisture is normal.
        else:                           # Abnormal temperature & moisture
            return (ftext+"+"+wtext)  # i.e. "Hot & Dry"
    
    def fire_climate (fire):    # Supplied a fire stat rating from -100 to +100, returns a word string describing heat or cold state. if 0 returns "".
        if fire > 0:
            if fire > 50:
                return "Hot"
            else:
                return "Warm"
        elif fire < 0:
            if fire < -50:
                return "Cold"
            else:
                return "Cool"
        else:
            return ""
            
    def water_climate (water):    # Supplied a water stat rating from -100 to +100, returns a word string describing heat or cold state. if 0 returns "".
        if water > 0:
            if water > 50:
                return "Wet"
            else:
                return "Moist"
        elif water < 0:
            if water < -50:
                return "Dry"
            else:
                return "Shriveled"
        else:
            return ""
            

            
            
#==================================================================================================================================
#==================================================================================================================================
# ====================================== CHOOSE TEAM:  ALL SCREENS TOGETHER  ======================================================
#==================================================================================================================================
#==================================================================================================================================
screen choose_team_roster:
    default tt1 = Tooltip("")   # TOOLTIP displays Plant info screen in the large central frame for Pteam hover
    default tt = Tooltip("")    # Top of screen standard tooltip with plant powers, Right side allies list
    default tt3 = Tooltip("")   # Bottom left tooltip, Left side Team Roster
    $ x_base =900               # Used by team list for positioning on right side
    $ y_base =150
    
    frame:                      # TOP TOOLTIP
        pos (315,0)             #top of screen tooltip with plant powers, Right side allies list
        has vbox: 
            text tt.value
    
    # ======= Pteam allies shown with no frame
    
    text("Plant Allies") xpos (x_base-45) ypos (y_base-80) size 40 underline True       # Right side top title         text("Roster") xalign 0.5 size 40

    text("TEAM") xpos 60 ypos (y_base-65) size 30 underline True                        # Left side top title
    
    text("Angelica") xpos (x_base) ypos (y_base-30)                                     # Names above plant icon, right side
    text("   Elder") xpos (x_base) ypos (y_base+120)
    text("Elecampane") xpos (x_base) ypos (y_base+270)
    
    text("Choose plants to \nadd to your team") xpos (x_base+120) ypos (y_base+440) size 25     #Static info text, right side
    # text("Unlock the third plant\nby winning a battle") xpos (x_base+120) ypos (y_base+480) size 25
        
                             # RIGHT SIDE, ALL ALLIES   # When plant clicked, set ally = 

    if (p_angelica.unlocked and p_angelica.active):      # Show available if unlocked AND not in roster yet             Pteam[1] is Angelica
        imagebutton auto (p_angelica.img+"%s.png") xpos (x_base) ypos (y_base) action [SetVariable("ally",p_angelica), SetVariable("allyN",Pteam[1].index), Hide("tooltip_team")] hovered tt.Action("Angelica Powers: "+p_angelica.txt[1]) activate_sound ClickSound  
    else: 
        imagebutton auto (p_angelica.img+"%s.png") xpos (x_base) ypos (y_base) action None
    if (p_elder.unlocked and p_elder.active):
        imagebutton auto (p_elder.img+"%s.png") xpos (x_base) ypos (y_base+150) action [SetVariable("ally",p_elder), SetVariable("allyN",Pteam[2].index), Hide("tooltip_team") ] hovered tt.Action("Elder Powers: "+p_elder.txt[1]) activate_sound ClickSound  
    else: 
        imagebutton auto (p_elder.img+"%s.png") xpos (x_base) ypos (y_base+150) action None
    if (p_elecampane.unlocked and p_elecampane.active):
        imagebutton auto (p_elecampane.img+"%s.png") xpos (x_base) ypos (y_base+300) action [SetVariable("ally",p_elecampane), SetVariable("allyN",Pteam[3].index), Hide("tooltip_team") ] hovered tt.Action("Elecampane Powers: "+p_elecampane.txt[1]) activate_sound ClickSound  
    else: 
        imagebutton auto (p_elecampane.img+"%s.png") xpos (x_base) ypos (y_base+300) action None

    vbox:                   # Buttons to assemble your team, bottom of left frame 
        xpos x_base ypos 600
        textbutton "ADD" action [SetVariable("add_Ateam", True), Return()] hovered tt3.Action("Add Ally to Roster")
        textbutton "CLEAR" action [SetVariable("clear_Ateam", True), Return()] hovered tt3.Action("Empty the Roster")
        textbutton "Start Battle" action [SetVariable("start_battle", True), Return(True)] hovered tt3.Action("Exit & Start Battle")


    #####screen plant_info_screen:  # TOOLTIP tt1
    frame:                                      # TOOLTIP: Plant info screen is the large central frame which is a tooltip for Pteam
        pos (250,60) minimum (600,650) maximum (600,650)  #all coordinates below this take the upper left corner of frame as (0,0)  
        add (ally.img+"idle.png") xalign 1.0 yalign 0.0
        text("Plant Ally Information") xpos 10 size 40
        $ x_basex = 150                         # Upper left corner of element grid in central Plant info Tooltip frame
        $ y_basex =275
        
        if ally.hasPower(HARVEST): # This area displays the plant power icons bottom center
            imagebutton auto "gui/iHarvest_%s.png" xpos (x_basex+100) ypos (y_basex+100) hovered tt1.Action("Harvest is a Nutritive Tonic. Increases Vitality") action NullAction()
        if ally.hasPower(FIRE):
            imagebutton auto "gui/iFire_%s.png" xpos (x_basex) ypos (y_basex) hovered tt1.Action("Fire is Warming & Stimulating\nCounters Earth (cold stagnant) conditions") action NullAction()
        if ally.hasPower(EARTH):                                                      
            imagebutton auto "gui/iEarth_%s.png" xpos (x_basex) ypos (y_basex+100) hovered tt1.Action("Earth is Cooling\nCounters Fire (overheated) conditions") action NullAction()
        if ally.hasPower(STORM): 
            imagebutton auto "gui/iStorm_%s.png" xpos (x_basex+100) ypos (y_basex) hovered tt1.Action("Storm is Antiseptic and Detoxifying\nCounters Swamp (stagnant, rotting & toxic) conditions") action NullAction()
        if ally.hasPower(AIR): 
            imagebutton auto "gui/iAir_%s.png" xpos (x_basex+200) ypos (y_basex) hovered tt1.Action("Air is Drying & Toning\nCounters River (mucus flow/diarrhea) conditions") action NullAction() 
        if ally.hasPower(RIVER): 
            imagebutton auto "gui/iRiver_%s.png" xpos (x_basex+200) ypos (y_basex+100) hovered tt1.Action("River is Hydrating (water)\nCounters Air (dry & atrophy) conditions") action NullAction() 
        if ally.hasPower(STONE):          
            imagebutton auto "gui/iStone_%s.png" xpos (x_basex) ypos (y_basex+200) hovered tt1.Action("Stone is Slowing (Sedative)\nCounters Fire (overstimulated & exhausted) conditions") action NullAction()
        if ally.hasPower(MOUNT): 
            imagebutton auto "gui/iMount_%s.png" xpos (x_basex+100) ypos (y_basex+200) hovered tt1.Action("Mountain is Relaxing\nCounters Storm (stress & spasm) conditions") action NullAction()
        if ally.hasPower(SWAMP): 
            imagebutton auto "gui/iSwamp_%s.png" xpos (x_basex+200) ypos (y_basex+200) hovered tt1.Action("Swamp is Moistening (oily)\nCounters Air (dry & atrophy) conditions") action NullAction()

        vbox:                   # Displays the plant text attributes and labels on left side of central tooltip frame
            xpos 10 ypos 60
            text ("Name:")
            text ("Latin Name:")
            text ("Powers:\n")
            text ('"'+ally.txt[2]+ '"')
            text (tt1.value) ypos 10
          #  text ("p_angelica.unlocked"+str(p_angelica.unlocked)+" "+"p_angelica.active"+str(p_angelica.active)+" ") # )   #+"Pteam[1].index" +str(Pteam[1].index)
          #  text ("add_:"+str(add_Ateam)+" "+"clear_"+str(clear_Ateam)+" "+"allyN:"+str(allyN)) #+" "+ "Ateam[0].active:"+str(Ateam[0].active)+" "+str(p_angelica.active)+" "+str((Ateam[0] == noPowers))) #tt3.value
            ###DEBUGGING####
            
            
        vbox:                   # Displays the plant text attributes and labels on right side of central tooltip frame
            xpos 150 ypos 60            
            text (ally.name)
            text (ally.txt[0])
            text (ally.txt[1])


    #####screen roster_screen:                           ############################################ LEFT SIDE, BATTLE TEAM  

    frame:                      ## uses tt3 TOOLTIP shows bottom left
        pos (25,60) minimum (200,650) maximum (200,650)  #all coordinates below this take the upper left corner of frame as (0,0)
        $ x_basez = 40          # Placement of Ateam allies on left side fream
        $ y_basez = 90 
        text("Roster") xalign 0.5 size 40
        add (Ateam[1].img+"idle.png") xpos (x_basez) ypos (y_basez)
        add (Ateam[2].img+"idle.png") xpos (x_basez) ypos (y_basez+150)
        add (Ateam[3].img+"idle.png") xpos (x_basez) ypos (y_basez+300)                  


        # Flags set by screens: clear_Ateam, add_Ateam, start_battle ## class Plant: ally (Ateam is used but not changed by screens)
            
###############################################################################

           
init -2:
    $PLANT_X_POS = 1000
    $PLANT_X_MIN_POS = 800
    transform bottom_right:
        xalign 1.0 yalign 1.0 alpha 0
        linear 8.0 alpha 1.0
        linear 8.0 alpha 0.0
    transform top_right:
        xalign 1.0 yalign 0.0 alpha 0
        linear 8.0 alpha 1.0
        linear 8.0 alpha 0.0
    transform bottom_left:
        xalign 0.0 yalign 1.0 alpha 0
        linear 8.0 alpha 1.0
        linear 8.0 alpha 0.0
    transform fadingin:
        #pos (0.0)
        alpha 0
        linear 8.0 alpha 1.0
        linear 8.0 alpha 0.0
    transform bottom_right_fade:
        linear 8.0 alpha 0.0
    transform top_right_fade:
        linear 8.0 alpha 0.0
    transform bottom_left_fade:
        linear 8.0 alpha 0.0
    transform fadingin_fade:
        linear 8.0 alpha 0.0        

    transform sneaky_disease1:   #move out of hiding and into position
        xpos -50 ypos 100 zoom 0.5 rotate 0
        easeout 3.0 xpos 600
        easeout 1.0 zoom 1.5     #starts slow, then speeds up ("ease" starts slow, speeds up, then slows down, "easein" starts fast then slows)
        easeout 2.0 zoom 1 
        easeout 1.0 xpos 100 ypos 300
    transform sneaky_disease_spread:
        xpos 100 ypos 300 rotate 0
        linear 0.5 zoom 1.5    
        linear 0.5 zoom 1 
        linear 0.5 zoom 1.5
        linear 0.5 zoom 1
    transform sneaky_disease_attack:
        xpos 100 ypos 300 zoom 1 rotate 0
        easeout .5 xpos 450     
        linear 1 xpos 100  
    transform sneaky_disease_boost:
       # around (.5, .5) alignaround (.5, .5) xalign .5 yalign .5
        xpos 100 ypos 300 rotate 0
        linear 0.3  rotate 30 #rotate_pad True
        linear 0.3  rotate 0 #rotate_pad True
        repeat 2
        
    transform valiant_plant_healing:
        xpos PLANT_X_POS rotate 0 
        linear 0.5 zoom 1.5    
        linear 0.5 zoom 1 
        linear 0.5 zoom 1.5
        linear 0.5 zoom 1
    transform valiant_plant_attack:
        xpos PLANT_X_POS zoom 1 rotate 0
        easeout .5 xpos PLANT_X_MIN_POS     
        linear 1 xpos PLANT_X_POS
    transform valiant_plant_boost:
       # around (.5, .5) alignaround (.5, .5) xalign .5 yalign .5
        xpos PLANT_X_POS rotate 0
        linear 0.3  rotate 30 #rotate_pad True
        linear 0.3  rotate 0 #rotate_pad True
        repeat 2
        
    transform blinkie:
        pos msg_pos alpha 0.0
        easeout 0.5 alpha 1.0
        0.5 # Pause
        linear 0.5 alpha 0.0
        repeat
    transform blinkie2:
        pos msg_pos alpha 0.0
        easeout 0.5 alpha 1.0
        0.5 # Pause
        linear 0.5 alpha 0.0
        repeat
    transform drop_status:
        xpos 300  ypos -100     # Start above the visible screen
        easein 1.0 ypos 75     # Drop down to 50 pixels from the tops to show status message
        3                       # 2.5 second Pause
        easeout 1.0 ypos -100    # Go back above the visible screen in 3 seconds to hide status message

    transform friend_status:
        xpos 700  ypos 720     # Start above the visible screen
        easein 1.0 ypos 450     # Drop down to 50 pixels from the tops to show status message
        3                       # 2.5 second Pause
        easeout 1.0 ypos 720    # Go back above the visible screen in 3 seconds to hide status message

    transform foe_status:
        xpos 100  ypos 720     # Start above the visible screen
        easein 1.0 ypos 450     # Drop down to 50 pixels from the tops to show status message
        3                       # 2.5 second Pause
        easeout 1.0 ypos 720    # Go back above the visible screen in 3 seconds to hide status message

    transform transparent25:
        linear 1.0 alpha 0.25
        
    transform transparent50:
        linear 1.0 alpha 0.5
        
    transform transparent75:
        linear 1.0 alpha 0.75
        
    transform opaque:
        linear 1.0 alpha 0.5
        
    
        

#dumb list: Screen errors, did you call it with the word SCREEN in show screen name?
# x =  takes a $ for python
# if using show screen, must have Hide("screen_name") inside to remove it. 
# if using call screen, screen ends with Return() 