# Screens and animations for the game

                                                # Do not use "hide screen" in main program, that would dismiss it too soon. 
                                                # SetVariable("player_text", client.getActionText()) for client version.

screen sickstat_change:                                 # Screen for showing status change message
    $ tempsick=sick.actiontext
    text (tempsick+"Effectiveness at "+str(client.earthImbalance())+"%") size 30: # Display string with size 30, use transform to drop in and float up the message
        at foe_status                  
    timer 5.0 action Hide("sickstat_change")            # The transform animation lasts 6.5 second, so dismiss the screen after 7 seconds. 

screen sickstat_change2:                                # DUPLICATES
    text (Ateam[1].name+": "+sick.actiontext) size 30:      
        at friend_status                  
    timer 5.0 action Hide("sickstat_change2")        

screen sickstat_change3:                             
    text (Ateam[2].name+": "+sick.actiontext) size 30:        
        at friend_status                  
    timer 5.0 action Hide("sickstat_change3")        
#------------------------------------------------
screen clientstat_change:                               # Screen for showing client status change message FOE side
    $ tempstat=client.actiontext
    text (tempstat+"Effectiveness at "+str(client.earthImbalance())+"%") size 30:              # Display string with size 30, use transform to drop in and float up the message
        at foe_status                  
    timer 5.0 action Hide("clientstat_change")          # The transform animation lasts 6.5 second, so dismiss the screen after 7 seconds. 

screen clientstat_change2:                              # Screen for showing client status change message FRIEND side
    $ tempstat2=client.actiontext
    text (Ateam[1].name+": "+tempstat2) size 30:     
        at friend_status                  
    timer 5.0 action Hide("clientstat_change2")        

screen clientstat_change3:                              # DUPLICATES, for second ally to use: Screen for showing status change message
    $ tempstat3=client.actiontext
    text (Ateam[2].name+": "+tempstat3) size 30:                
        at friend_status                  
    timer 5.0 action Hide("clientstat_change3") 
    
screen popup_plant1(actor1, result1, msg1, sign1):              #Duplicates, so up to three status screens can show at once
    text (actor1+": "+sign1+str(result1)+" "+msg1) size 30:                
        at friend_status                  
    timer 5.0 action Hide("popup_plant1")
    
screen popup_plant2(actor2, result2, msg2, sign2):  
    text (actor2+": "+sign2+str(result2)+" "+msg2) size 30:                
        at friend_status                  
    timer 5.0 action Hide("popup_plant2")
    
screen popup_plant3(actor3, result3, msg3, sign3):  
    text (actor3+": "+sign3+str(result3)+" "+msg3) size 30:                
        at friend_status                  
    timer 5.0 action Hide("popup_plant3")


                

                                                               
    
screen achievement(msg1,size1=30):                              # DUPLICATES, for second ally to use: Screen for showing status change message
    text (msg1) size size1:             
        at friend_status                  
    timer 5.0 action Hide("achievement") 

screen mocking:
    use show_team                                               #So the plant team doesn't dissappear during the dialog, before it's called again
    frame: 
        xalign 0.5 yalign 0.5
        vbox:
            text str("Disease Spirit says:")
            text str("Ha ha ha! Your puny "+getElemName(elemChoice)+" attack")
            text str("means nothing to me, I am immune!") 
            textbutton "Continue" xalign 1.0 action [Hide("show_team"), Return()]
                                                
screen disclaimer:
    frame: 
        xalign 0.5 yalign 0.5
        vbox:
            text str("DISCLAIMER") size 40 underline True
            text str("    This game can be played just for fun, or to assist in learning about plants \nand principles of Traditional Western Herbalism. What works in the game \nwill {i}not{/i} work the same way in real life. It's just a game.")
            text str("\n    -Do not use plants medicinally without supervision of a medical doctor \nor appropriate health professional, as defined by the laws of your country.")
            text str("\n    -Do not summon plant spirits to battle diseases without supervision \nof a witch doctor or appropriate shamanic professional, as defined by \nyour spiritual tradition.") 
            text str("\nHave fun!\n")

            textbutton "Agree" action Return()
            textbutton "Refuse" action Jump("negotiate")
            textbutton "Learn More" action Show("references")

screen references:
    frame: 
        xalign 0.5 yalign 0.5
        vbox:
            text str("For Further Learning:") underline True
            text str("\n    {i}'The Practice of Traditional Western Herbalism'{/i} and {i}'The Earthwise Herbal: \nA Complete Guide to Old World Medicinal Plants'{/i} by Matthew Wood are \ngreat resources to study Herbal Energetics and medicinal usage, respectively.")
            text str("\n    {i}'The Northern Shamanic Herbal'{/i} by Raven Kaldera covers magical, spiritual \nand medicinal aspects. With plant spirit personality descriptions and pictures \nof what these plant spirits look like to the author, it's basically the \n'Creature Manual' reference for this game.")
            text str("\n    {i}'Natural Healing with Herbs'{/i} by Humbart Santillo was also used to cross-\nreference plant properties and usage for the game.\n\n\n\n\n\n\n")
            textbutton "Continue" action Hide("references")
                                                
screen bigMessage (msg1,msg2="",msg3="", size1=40,size2=30): #Has Hide() so can use show screen bigMessage to call it
    key 'K_RETURN' action [Hide("bigMessage"),Return()]         # Enter or Return key to exit dialog
    key 'K_KP_ENTER' action [Hide("bigMessage"),Return()]

    frame: 
        xalign 0.5 yalign 0.3
        vbox:
           text msg1 size size1 first_indent 70
           text "" size 15
           text msg2 size size2 first_indent 70
           text msg3 size size2 first_indent 70
           text "" size size1                           #Start with button selected, so Enter/Return keys will work.
           textbutton "{size=+10}Continue{/size}" default True action [Hide("bigMessage"),Return()] # Click on button, Enter key or Return key to dismiss

           
screen bigChoice (msg1,msg2="",msg3="", size1=40,size2=30):  # Returns a value, so use call screen bigChoice()
    frame: 
        xalign 0.5 yalign 0.3 minimum (800,200) maximum (800,650)
        vbox:
           text msg1 size size1 first_indent 70
           text "" size 15
           text msg2 size size2 first_indent 70
           text msg3 size size2 first_indent 70
           textbutton "Yes" action [Return("y"),Hide("bigChoice")]
           textbutton "No" action [Return ("n"),Hide("bigChoice")]
           
screen restartGame:
    frame: 
        xalign 1.0 yalign 1.0
        has vbox:
                textbutton "{size=+10}RESTART{/size}" action MainMenu(confirm=True)

screen disease_stats:
    frame:
        xpos 25
        has vbox
        text ("{u}DISEASE{/u}") underline True
        text ("Spread: "+str(sick.spread)+"/1000")
        text ("Effectiveness: "+str(sick.effect)+"%")  #client.earthImbalance()
        text ("              ... (More) ...") size 12
    vbox:
        vbar value (sick.spread) range 1000  xpos 10 ypos 50 ymaximum 500 #thumb None

    mousearea:
        area (0, 0, 200, 75)
        hovered [Show("full_disease_stats", transition=dissolve),Show("full_villager_stats", transition=dissolve)]
        unhovered [Hide("full_disease_stats", transition=dissolve), Hide("full_villager_stats", transition=dissolve)]

screen full_disease_stats:
    frame:
        xpos 25
        has vbox
        text ("{u}DISEASE{/u}") underline True
        text ("Spread: "+str(sick.spread)+"/1000")
        text ("Effectiveness: "+str(sick.effect)+"%")  #client.earthImbalance()
        text ("Type: "+getElemName(sick.element)+" "+sick.target)
        #text ("Element:"+getElemName(sick.element))    # MORE button
        
        text ("Weak to: Fire")
        text ("{u}Disease Powers{/u}") underline True 
        text ("Earth: 10")
        text ("(Strike:50-100)")
        

        
screen disease_stats_tutor:
    frame:
        xpos 25
        has vbox
        text ("{u}DISEASE{/u}") underline True
        text ("Spread: "+str(sick.spread)+"/1000")
        text ("Effectiveness: "+str(sick.effect)+"%")  #client.earthImbalance()
        text ("              ... (More) ...") size 12
    vbox:
        vbar value (sick.spread) range 1000  xpos 10 ypos 50 ymaximum 500 #thumb None
    mousearea:
        area (0, 0, 200, 75)
        hovered [Show("full_disease_stats", transition=dissolve), SetVariable("learn_step",5)]
        unhovered [Hide("full_disease_stats", transition=dissolve), SetVariable("learn_step",4)]
        
screen villager_stats_tutor:
    frame:
        xpos 1040 #yminimum 210
        has vbox
        text ("{u}   VILLAGER{/u}") underline True
        text ("Vitality: "+str(client.vitality)+"/1000")
        text ("Climate: "+climate_text (client.fire, client.water))
    vbox:
        vbar value (client.vitality) range 1000  xpos 1255 ypos 50 ymaximum 500 #thumb None
    mousearea:
        area (1050, 0, 1280, 75)
        hovered [Show("full_villager_stats", transition=dissolve), SetVariable("learn_step",7)]
        unhovered [Hide("full_villager_stats", transition=dissolve), SetVariable("learn_step",6)]

screen villager_stats:
    frame:
        xpos 1040 #yminimum 210
        has vbox
        text ("{u}   VILLAGER{/u}") underline True
        text ("Vitality: "+str(client.vitality)+"/1000")
        text ("Climate: "+climate_text (client.fire, client.water))
        text ("              ... (More) ...") size 12
    vbox:
        vbar value (client.vitality) range 1000  xpos 1255 ypos 50 ymaximum 500 #thumb None
    mousearea:
        area (1050, 0, 1280, 75)
        hovered [Show("full_disease_stats", transition=dissolve),Show("full_villager_stats", transition=dissolve)]
        unhovered [Hide("full_disease_stats", transition=dissolve), Hide("full_villager_stats", transition=dissolve)]
        
screen full_villager_stats:
    frame:
        xpos 1040 yminimum 210
        has vbox
        text ("{u}   VILLAGER{/u}") underline True
        text ("Vitality: "+str(client.vitality)+"/1000")
        text ("Climate: "+climate_text (client.fire, client.water))
        text (" ")
        if client.fire > 0:  #show the PLUS sign if positive, MINUS if negative (using em-dash), nothing if zero
            text ("+")  
        elif client.fire < 0:
            text ("‒")
        if client.earth > 0:
            text ("+")  
        elif client.earth < 0:
            text ("‒")
        if client.air > 0:
            text ("+")  
        elif client.air < 0:
            text ("‒")
        if client.water > 0:
            text ("+")  
        elif client.water < 0:
            text ("‒")

    vbox:                   
        xpos 1130 ypos 109        # chars are about 27 pixels  . Line 3 at 55 pixels, line 4 at 82
        text ("Fire")          
        text ("Earth")          
        text ("Air")           
        text ("Water")        
        #text ("Stress")        
        #text ("Toxins")  
    vbox:                  
        xpos 1070 ypos 109
        text (str(abs(client.fire)))
        text (str(abs(client.earth)))
        text (str(abs(client.air)))
        text (str(abs(client.water)))
        #text (str(client.stress/10)+"%")
        #text (str(client.toxic/10)+"%")



        


         
         

screen battle_button:                           ###DEADCODE###
    frame:                                      #all coordinates below this take the upper left corner of frame as (0,0)
        pos (10,650) # minimum (200,650) maximum (200,650)
        textbutton "Start Battle" action [SetVariable("start_battle", True), Return(True)]

screen bloodshot:                            
       # pos (0,0) #minimum (200,650) maximum (200,650)
#        add (Ateam[0].img+"idle.png") xpos (x_basez) ypos (y_basez)
        if client.vitality < 100:                           # Creepy blood haze around screen as vitality goes down
            add ("gui/HWbg_blood_FULL.png") pos (0,0) #at fadingin
        if client.vitality < 200:
            add ("gui/HWbg_blood_BL.png") xalign 0.0 yalign 1.0 #at fadingin 
        if client.vitality < 300:
            add ("gui/HWbg_blood_TR.png") xalign 1.0 yalign 0.0 #at fadingin
        if client.vitality < 400: 
            add("gui/HWbg_blood_BR.png") xalign 1.0 yalign 1.0 #at fadingin


        


#==================================================================================================================================
#==================================================================================================================================
# ====================================== BATTLE SCREENS  ==========================================================================
#==================================================================================================================================
#==================================================================================================================================

# ■██▓▒░ TURN_FRAME screen: shows who is fighting ░▒▓████████████████████████████████████■ No side effects
screen Turn_frame:     # Displays Fire/Earth Air/Water Stress/Toxins, activated in Say screen
    $top_y    = 182     
    $bottom_y = 305     # Position variables makes it easier to move/adjust all the displays at once. 
    $left_x  = 315
    $right_x = 885
    $fourChars = 60

    
    if ((1 <= step) and (step <= 3)):      # Element chosen, then choose FIGHT, BOOST or NOTHING as action in Tooltip
        #imagebutton auto "gui/iFire_%s.png" xpos (x_base) ypos (100+y_base) action [SetVariable("elemChoice",FIRE), ShowTransient('tooltip_action')] hover_sound ClickSound activate_sound HealSound 
        frame:
            xpos 850 ypos 0        #Right side for Health
            vbox:
                text ("Round: "+str(Rounds))
                text ("Turn: Disease")   #str(client.vitalStat()/10)+"%") min_width fourChars text_align 1.0
    elif ((4 <= step) and (step <= 9)):   
        key 'K_KP0' action [SetVariable("step", 1), SetVariable("playerAction", SKIP), Return()]                # Keypad key 0 to skip turn
        frame:
            xpos 850 ypos 0        #Right side for Health
            vbox:
                text ("Round: "+str(Rounds))
                text ("Turn: Healer")  # str(client.vitalStat()/10)+"%") min_width fourChars text_align 1.0
                textbutton ("Skip turn") action [SetVariable("step", 1), SetVariable("playerAction", SKIP), Return()]
                

   # HEAL FIGHT, BOOST, NOTHING
        
screen tooltip_action:          # elemChoice has been set to the element pressed (int)
    default tt = Tooltip("No button selected.")
    if step >4:                                                                 #Tooltip shows only during player turn
        frame:
            xpos xpos_tt ypos ypos_tt xmaximum 200               #xpos xtt ypos ytt 
            xfill True
            has vbox
            if (elemChoice == HARVEST):
                textbutton ("Boost Vitality"):
                    action [SetVariable("playerAction", HEAL), Return(HEAL)]
                    hovered tt.Action("Nutritive Tonic increases vitality.")
                key "K_KP_DIVIDE" action [SetVariable("playerAction", HEAL), Return(HEAL)] #K_KP1 keypad

                textbutton "Cancel":
                    action [SetVariable("playerAction", NOTHING), Hide('tooltip_action')]
                    hovered tt.Action("Do something else.")        
                key "K_KP_MINUS" action [SetVariable("playerAction", NOTHING), Hide('tooltip_action')] # Hide the tooltip, don't Return yet!
                
            else:     
                textbutton (getElemName(elemChoice)+" Attack"):
                    action [SetVariable("playerAction", FIGHT), Return(FIGHT)]
                    hovered tt.Action("Reduces spread of the disease.")
                key "K_KP_DIVIDE" action [SetVariable("playerAction", FIGHT), Return(FIGHT)]

                textbutton ("Boost "+getElemName(elemChoice)):
                    action [SetVariable("playerAction", BOOST), Return(BOOST)]
                    hovered tt.Action("Disease does less damage/spread when elements are balanced.")
                key "K_KP_MULTIPLY" action[SetVariable("playerAction", BOOST), Return(BOOST)]
                
                textbutton "Cancel":
                    action [SetVariable("playerAction", NOTHING),Hide('tooltip_action')] # Cancel does not return and end the call screen. Continue in screens. 
                    hovered tt.Action("Do something else.")    
                key "K_KP_MINUS" action[SetVariable("playerAction", NOTHING), Hide('tooltip_action')]
                
           # key "K_PLUS" action [SetVariable("allyN", If(allyN==1, 2, 1))]      # Toggle between allies when + key is pressed. If(expression, true=None, false=None)

            text tt.value
            
screen show_team:
    $ x_base = 1000 #900
    $ y_base = 200 #150
    default tt = Tooltip("")
    if tt.value != "":                          #Only show the tooltip frame if it isn't empty
        frame:                                  #frame background None: 
            pos (300,75) 
            has vbox: 
                text tt.value

    text("PLANT ALLIES") xpos (x_base-45) ypos (y_base-65) size 30 underline True
    text("DISEASE") xpos 60 ypos (y_base-65) size 30 underline True
    
    text("Angelica") xpos (x_base) ypos (y_base-30)
    text("   Elder") xpos (x_base) ypos (y_base+120)
            # When plant clicked, set allyN = 
    if step > 4:                                                        #################### CHANGE THIS #############################
        
                #    key "K_PLUS" action [SetVariable("allyN", If(allyN==2, 1, 2))]      # Toggle between allies when + key is pressed. If(expression, true=None, false=None)
        
        if Ateam[1].active:
            imagebutton auto (Ateam[1].img+"%s.png") xpos (x_base) ypos (y_base) action [SelectedIf(allyN==1), SetVariable("allyN",1),
                Hide("tooltip_action")] hovered tt.Action(Ateam[1].name+" Powers: "+Ateam[1].txt[1]) hover_sound ClickSound activate_sound HealSound 
        else: 
            imagebutton auto (Ateam[1].img+"%s.png") xpos (x_base) ypos (y_base) action None

        if Ateam[2].active:

            imagebutton auto (Ateam[2].img+"%s.png") xpos (x_base) ypos (y_base+150) action [SelectedIf(allyN==2), SetVariable("allyN",2),
                Hide("tooltip_action")] hovered tt.Action(Ateam[2].name+" Powers: "+Ateam[2].txt[1]) hover_sound ClickSound activate_sound HealSound 
        else: 
            imagebutton auto (Ateam[2].img+"%s.png") xpos (x_base) ypos (y_base+150) action None
            
    else:             # Show inactive plants during disease turn
        imagebutton auto (Ateam[1].img+"%s.png") xpos (x_base) ypos (y_base) action None
        imagebutton auto (Ateam[2].img+"%s.png") xpos (x_base) ypos (y_base+150) action None
    
##########################################################################################################################################

screen show_team_tutor:#################### UPDATE THIS #############################
    $ x_base =900
    $ y_base =150
    default tt = Tooltip("")          
    if tt.value != "":                          #Only show the tooltip frame if it isn't empty
        frame:                                  #frame background None: 
            pos (300,75) 
            has vbox: 
                text tt.value
                
    text("PLANT ALLIES") xpos (x_base-45) ypos (y_base-65) size 30 underline True
    text("DISEASE") xpos 60 ypos (y_base-65) size 30 underline True
    
    text("Angelica") xpos (x_base) ypos (y_base-30)
    text("   Elder") xpos (x_base) ypos (y_base+120)
            # When plant clicked, set ally = 
            
#    if step > 4:
#        if angelica_active:
#            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action [SetVariable("ally",p_angelica), Hide("tooltip_action")] hovered tt.Action("Angelica Powers: Fire:9, Harvest:4, Swamp:3") hover_sound ClickSound activate_sound HealSound 
#        else: 
#            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action None
#        if elder_active:
#            imagebutton auto "sprite/iElder_%s.png" xpos (x_base) ypos (y_base+150) action [SetVariable("ally",p_elder), Hide("tooltip_action") ] hovered tt.Action(" Elder Powers: Earth:9, Mountain:8, ,\nStone:7, Fire:5, River:3") hover_sound ClickSound activate_sound HealSound 
#        else: 
#            imagebutton auto "sprite/iElder_%s.png" xpos (x_base) ypos (y_base+150) action None

    if learn_step < 6:
        if angelica_active :
            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action [SelectedIf(False),
                Hide("tooltip_action_tutor")] hovered [tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1]), SetVariable("learn_step",6)] hover_sound ClickSound activate_sound HealSound 
        else: 
            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action None
    elif learn_step < 7: 
        if angelica_active :
            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action [SelectedIf(ally == p_angelica), SetVariable("ally",p_angelica),SetVariable("allyN",1), SetVariable("learn_step",7),
                Hide("tooltip_action_tutor")] hovered [tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1])] hover_sound ClickSound activate_sound HealSound 
        else: 
            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action None        
    else:
        if angelica_active :
            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action [SelectedIf(ally == p_angelica), SetVariable("ally",p_angelica),SetVariable("allyN",1),
                Hide("tooltip_action_tutor")] hovered [tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1])] hover_sound ClickSound activate_sound HealSound 
        else: 
            imagebutton auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) action None        

    if elder_active:
        imagebutton auto "sprite/iElder_%s.png" xpos (x_base) ypos (y_base+150) action [SelectedIf(ally == p_elder), SetVariable("ally",p_elder),SetVariable("allyN",2),
            Hide("tooltip_action_tutor")] hovered tt.Action(p_elder.name+" Powers: "+p_elder.txt[1]) hover_sound ClickSound activate_sound HealSound 
    else: 
        imagebutton auto "sprite/iElder_%s.png" xpos (x_base) ypos (y_base+150) action None


    mousearea:
        area (x_base, y_base, x_base+100, y_base+100)
        hovered [SetVariable("learn_step", 6)]
        unhovered [SetVariable("learn_step", 7) ]
            
            
screen element_grid: # ■██▓▒░ BATTLEGRID_player screen ░▒▓████████████████████████████████████■
    $ x_base = 500
    $ y_base =150
    default tt = Tooltip("")
    if tt.value != "":                          #Only show the tooltip frame if it isn't empty
        frame:
            pos (300,0)
            has vbox: 
                text tt.value 

    #Responds to keyboard numbers and keypad for 9 element grid. Make sure the sound is the same. 

    if Ateam[allyN].hasPower(HARVEST):
        imagebutton auto "gui/iHarvest_%s.png" xpos (x_base+100) ypos (y_base+100) action [SetVariable("elemChoice",HARVEST), SelectedIf(False),
            SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base+100),
            ShowTransient('tooltip_action')] hovered tt.Action("Harvest is a Nutritive Tonic\nIncreases Vitality") hover_sound ClickSound activate_sound HealSound 
        key "K_5" action [SetVariable("elemChoice",HARVEST), SelectedIf(False), SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base+100),Play('sound', "mus/.wav"), 
            tt.Action("Harvest is a Nutritive Tonic\nIncreases Vitality"), ShowTransient('tooltip_action')] 
        key "K_KP5" action [SetVariable("elemChoice",HARVEST), SelectedIf(False), SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base+100),Play('sound', "mus/alert.wav"), 
            tt.Action("Harvest is a Nutritive Tonic\nIncreases Vitality"), ShowTransient('tooltip_action')]  
        
    if Ateam[allyN].hasPower(FIRE):                                                          # Element chosen, then choose FIGHT, BOOST or NOTHING as action in Tooltip ((xtt=x_base-200),(ytt=y_base))
        imagebutton auto "gui/iFire_%s.png" xpos (x_base) ypos (y_base) action [SetVariable("elemChoice",FIRE), SelectedIf(False),
            SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base),
            ShowTransient('tooltip_action')] hovered tt.Action("Fire is Warming & Stimulating\nCounters Earth (cold stagnant) conditions") hover_sound ClickSound activate_sound HealSound
        key "K_7" action [SetVariable("elemChoice",FIRE), SelectedIf(False), SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base),Play('sound', "mus/alert.wav"),
            tt.Action("Fire is Warming & Stimulating\nCounters Earth (cold stagnant) conditions"), ShowTransient('tooltip_action')]         
        key "K_KP7" action [SetVariable("elemChoice",FIRE), SelectedIf(False), SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base),Play('sound', "mus/alert.wav"),
            tt.Action("Fire is Warming & Stimulating\nCounters Earth (cold stagnant) conditions"), ShowTransient('tooltip_action')]         

    if Ateam[allyN].hasPower(EARTH):                                                      
        imagebutton auto "gui/iEarth_%s.png" xpos (x_base) ypos (y_base+100) action [SetVariable("elemChoice",EARTH), SelectedIf(False),
            SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base+100),
            ShowTransient('tooltip_action')] hovered tt.Action("Earth is Cooling\nCounters Fire (overheated) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_4" action [SetVariable("elemChoice",EARTH), SelectedIf(False), SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base+100), Play('sound', "mus/alert.wav"),
            tt.Action("Earth is Cooling\nCounters Fire (overheated) conditions"),ShowTransient('tooltip_action')]  
        key "K_KP4" action [SetVariable("elemChoice",EARTH), SelectedIf(False), SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base+100), Play('sound', "mus/alert.wav"),
            tt.Action("Earth is Cooling\nCounters Fire (overheated) conditions"),ShowTransient('tooltip_action')]  
        
    if Ateam[allyN].hasPower(STORM): 
        imagebutton auto "gui/iStorm_%s.png" xpos (x_base+100) ypos (y_base) action [SetVariable("elemChoice",STORM), 
            SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base),
            ShowTransient('tooltip_action')] hovered tt.Action("Storm is Antiseptic and Detoxifying\nCounters Swamp (stagnant, rotting & toxic) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_8" action [SetVariable("elemChoice",STORM), SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base),Play('sound', "mus/alert.wav"),
            tt.Action("Storm is Antiseptic and Detoxifying\nCounters Swamp (stagnant, rotting & toxic) conditions"),ShowTransient('tooltip_action')] 
        key "K_KP8" action [SetVariable("elemChoice",STORM), SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base),Play('sound', "mus/alert.wav"),
            tt.Action("Storm is Antiseptic and Detoxifying\nCounters Swamp (stagnant, rotting & toxic) conditions"),ShowTransient('tooltip_action')] 
        
    if Ateam[allyN].hasPower(AIR): 
        imagebutton auto "gui/iAir_%s.png" xpos (x_base+200) ypos (y_base) action [SetVariable("elemChoice",AIR), 
            SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base),
            ShowTransient('tooltip_action')] hovered tt.Action("Air is Drying & Toning\nCounters River (mucus flow/diarrhea) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_9" action [SetVariable("elemChoice",AIR), SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base),Play('sound', "mus/alert.wav"),
            tt.Action("Air is Drying & Toning\nCounters River (mucus flow/diarrhea) conditions"),ShowTransient('tooltip_action')] 
        key "K_KP9" action [SetVariable("elemChoice",AIR), SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base),Play('sound', "mus/alert.wav"),
            tt.Action("Air is Drying & Toning\nCounters River (mucus flow/diarrhea) conditions"),ShowTransient('tooltip_action')]  
            
    if Ateam[allyN].hasPower(RIVER): 
        imagebutton auto "gui/iRiver_%s.png" xpos (x_base+200) ypos (y_base+100) action [SetVariable("elemChoice",RIVER), 
            SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base+100),
            ShowTransient('tooltip_action')] hovered tt.Action("River is Hydrating (water)\nCounters Air (dry & atrophy) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_6" action [SetVariable("elemChoice",RIVER), SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base+100),Play('sound', "mus/alert.wav"),
            tt.Action("River is Hydrating (water)\nCounters Air (dry & atrophy) conditions"),ShowTransient('tooltip_action')] 
        key "K_KP6" action [SetVariable("elemChoice",RIVER), SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base+100),Play('sound', "mus/alert.wav"),
            tt.Action("River is Hydrating (water)\nCounters Air (dry & atrophy) conditions"),ShowTransient('tooltip_action')]  
            
    if Ateam[allyN].hasPower(STONE):          
        imagebutton auto "gui/iStone_%s.png" xpos (x_base) ypos (y_base+200) action [SetVariable("elemChoice",STONE), 
            SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base+200),
            ShowTransient('tooltip_action')] hovered tt.Action("Stone is Slowing (Sedative)\nCounters Fire (overstimulated & exhausted) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_1" action [SetVariable("elemChoice",STONE), SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base+200),Play('sound', "mus/alert.wav"),
            tt.Action("Stone is Slowing (Sedative)\nCounters Fire (overstimulated & exhausted) conditions"),ShowTransient('tooltip_action')] 
        key "K_KP1" action [SetVariable("elemChoice",STONE), SetVariable("xpos_tt",x_base-200), SetVariable("ypos_tt",y_base+200),Play('sound', "mus/alert.wav"),
            tt.Action("Stone is Slowing (Sedative)\nCounters Fire (overstimulated & exhausted) conditions"),ShowTransient('tooltip_action')]  
            
    if Ateam[allyN].hasPower(MOUNT): 
        imagebutton auto "gui/iMount_%s.png" xpos (x_base+100) ypos (y_base+200) action [SetVariable("elemChoice",MOUNT), 
            SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base+200),
            ShowTransient('tooltip_action')] hovered tt.Action("Mountain is Relaxing\nCounters Storm (stress & spasm) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_2" action [SetVariable("elemChoice",MOUNT), SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base+200),Play('sound', "mus/alert.wav"),
            tt.Action("Mountain is Relaxing\nCounters Storm (stress & spasm) conditions"),ShowTransient('tooltip_action')] 
        key "K_KP2" action [SetVariable("elemChoice",MOUNT), SetVariable("xpos_tt",x_base+200), SetVariable("ypos_tt",y_base+200),Play('sound', "mus/alert.wav"),
            tt.Action("Mountain is Relaxing\nCounters Storm (stress & spasm) conditions"),ShowTransient('tooltip_action')]  
            
    if Ateam[allyN].hasPower(SWAMP): 
        imagebutton auto "gui/iSwamp_%s.png" xpos (x_base+200) ypos (y_base+200) action [SetVariable("elemChoice",SWAMP), 
            SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base+200),
            ShowTransient('tooltip_action')] hovered tt.Action("Swamp is Moistening (oily)\nCounters Air (dry & atrophy) conditions") hover_sound ClickSound activate_sound HealSound 
        key "K_3" action [SetVariable("elemChoice",SWAMP), SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base+200),Play('sound', "mus/alert.wav"),
            tt.Action("Swamp is Moistening (oily)\nCounters Air (dry & atrophy) conditions"),ShowTransient('tooltip_action')] 
        key "K_KP3" action [SetVariable("elemChoice",SWAMP), SetVariable("xpos_tt",x_base+300), SetVariable("ypos_tt",y_base+200),Play('sound', "mus/alert.wav"),
            tt.Action("Swamp is Moistening (oily)\nCounters Air (dry & atrophy) conditions"),ShowTransient('tooltip_action')] 
        

screen tooltip_action_tutor:          # elemChoice has been set to the element pressed (int)
    default tt = Tooltip("No button selected.")
                                                            #Tooltip shows only during player turn
    frame:
        xpos xpos_tt ypos ypos_tt xmaximum 200               #xpos xtt ypos ytt 
        xfill True
        has vbox
        
        if learn_step == 8:                     # Only Attack is enabled
            if (elemChoice == FIRE):
                textbutton (getElemName(elemChoice)+" Attack"):
                    action [SetVariable("playerAction", FIGHT), SetVariable("learn_step", 9),SetVariable("allyN",2),Return(FIGHT)]
                    hovered tt.Action("Reduces spread of the disease.")
                key "K_KP_DIVIDE" action [SetVariable("playerAction", FIGHT), Return(FIGHT)]

                textbutton ("Boost "+getElemName(elemChoice)):
                    action [SetVariable("playerAction", NOTHING)]
                    hovered tt.Action("Disease does less damage/spread when elements are balanced.")
                key "K_KP_MULTIPLY" action[SetVariable("playerAction", NOTHING), Return(BOOST)]
                
                textbutton "Cancel":
                    action [SetVariable("playerAction", NOTHING),Hide('tooltip_action_tutor')] # Cancel does not return and end the call screen. Continue in screens. 
                    hovered tt.Action("Do something else.")    
                key "K_KP_MINUS" action[SetVariable("playerAction", NOTHING), Hide('tooltip_action_tutor')]    
                
        elif learn_step == 9:                  #  Only Boost is enabled
            if (elemChoice == FIRE):
                textbutton (getElemName(elemChoice)+" Attack"):
                    action [SetVariable("playerAction", NOTHING)]
                    hovered tt.Action("Reduces spread of the disease.")
                key "K_KP_DIVIDE" action [SetVariable("playerAction", NOTHING)]

                textbutton ("Boost "+getElemName(elemChoice)):
                    action [SetVariable("playerAction", BOOST), SetVariable("learn_step", 10), SetVariable("allyN",1),Return(BOOST)]
                    hovered tt.Action("Disease does less damage/spread when elements are balanced.")
                key "K_KP_MULTIPLY" action[SetVariable("playerAction", NOTHING), Return(BOOST)]
                
                textbutton "Cancel":
                    action [SetVariable("playerAction", NOTHING),Hide('tooltip_action_tutor')] # Cancel does not return and end the call screen. Continue in screens. 
                    hovered tt.Action("Do something else.")    
                key "K_KP_MINUS" action[SetVariable("playerAction", NOTHING), Hide('tooltip_action_tutor')]       
        
        elif learn_step == 10:                  #  Only Harvest is enabled
            if (elemChoice == HARVEST):
                textbutton ("Boost Vitality"):
                    action [SetVariable("playerAction", HEAL), SetVariable("learn_step", 11), Return(HEAL)]
                    hovered tt.Action("Nutritive Tonic increases vitality.")
                key "K_KP_DIVIDE" action [SetVariable("playerAction", HEAL), Return(HEAL)] #K_KP1 keypad

                textbutton "Cancel":
                    action [SetVariable("playerAction", NOTHING), Hide('tooltip_action_tutor')]
                    hovered tt.Action("Do something else.")        
                key "K_KP_MINUS" action [SetVariable("playerAction", NOTHING), Hide('tooltip_action_tutor')] # Hide the tooltip, don't Return yet!
                
            elif learn_step==66:   ##### DELETE THIS BLOCK  
                textbutton (getElemName(elemChoice)+" Attack"):
                    action [SetVariable("playerAction", FIGHT), SetVariable("learn_step", 9),Return(FIGHT)]
                    hovered tt.Action("Reduces spread of the disease.")
                key "K_KP_DIVIDE" action [SetVariable("playerAction", FIGHT), Return(FIGHT)]

                textbutton ("Boost "+getElemName(elemChoice)):
                    action [SetVariable("playerAction", BOOST), Return(BOOST)]
                    hovered tt.Action("Disease does less damage/spread when elements are balanced.")
                key "K_KP_MULTIPLY" action[SetVariable("playerAction", BOOST), Return(BOOST)]
                
                textbutton "Cancel":
                    action [SetVariable("playerAction", NOTHING),Hide('tooltip_action_tutor')] # Cancel does not return and end the call screen. Continue in screens. 
                    hovered tt.Action("Do something else.")    
                key "K_KP_MINUS" action[SetVariable("playerAction", NOTHING), Hide('tooltip_action_tutor')]
                
           # key "K_PLUS" action [SetVariable("allyN", If(allyN==1, 2, 1))]      # Toggle between allies when + key is pressed. If(expression, true=None, false=None)

        text tt.value
        
screen battle_tutor: 
    $ x_base =900                               # plant positions
    $ y_base =150
    default tt = Tooltip("")          
    if tt.value != "":                          # Plant Power Ratings Tooltip: Only show the tooltip frame if it isn't empty
        frame:                                  # frame background None: 
            pos (300,75) 
            has vbox: 
                text tt.value
                
    text(str(learn_step)+"PLANT ALLIES") xpos (x_base-45) ypos (y_base-65) size 30 underline True
    text("DISEASE") xpos 60 ypos (y_base-65) size 30 underline True
    
    text("Angelica") xpos (x_base) ypos (y_base-30)
    text("   Elder") xpos (x_base) ypos (y_base+120)
            # When plant clicked, set ally = 

    if learn_step == 5:     # learn_step 5: Show Angelica and Elder, they look alive but are just images. Step increment done in script
        add "sprite/iAngelica_idle.png" xpos (x_base) ypos (y_base)
        add "sprite/iElder_idle.png" xpos (x_base) ypos (y_base+150)
  
    elif learn_step == 6:   # learn_step 6: Ask to hover angelica to see powers tooltip. Mousearea Hover makes it 7. Still static images until then
        add "sprite/iAngelica_idle.png" xpos (x_base) ypos (y_base)
        add "sprite/iElder_idle.png" xpos (x_base) ypos (y_base+150)
        
        mousearea: #Area upper left corner, width and height
            area (x_base, y_base, 100,100) #Hovered: Increment step to 7, Set allyN to zero so not selected yet. Display Plant Rating Tooltip
            hovered [SetVariable("learn_step", 7), SetVariable("allyN", 0), tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1])]
           
    elif learn_step == 7:      # learn_step 7: Still show Plant Tooltip. Explain powers, ask to click on Angelica (starts unselected).  Click makes it 8
        imagebutton:
            auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) 
            action [SelectedIf(allyN == 1), SetVariable("allyN",1), SetVariable("learn_step",8)] # Step is set in tooltip_action_tutor after this
            hovered [tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1])] 
            hover_sound ClickSound activate_sound HealSound 
        add "sprite/iElder_idle.png" xpos (x_base) ypos (y_base+150)
        
        
        #BUG########### Element info tooltip  not showing
    elif learn_step == 8:      # learn_step 8: Show three elements. Ask to click Fire, then Fire Attack
                               # ask to click on Fire, that makes it 9.
        $showElem = [FIRE, HARVEST, SWAMP]
        use element_grid_tutor
        imagebutton:
            auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) 
            action [SelectedIf(allyN == 1), SetVariable("allyN",1)]      
            hovered [tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1])] 
            hover_sound ClickSound activate_sound HealSound 
        add "sprite/iElder_idle.png" xpos (x_base) ypos (y_base+150)
        
    elif learn_step == 9: # learn_step 9: Mention Angie goes grey. Click on Elder. Ask to click Fire Boost, that makes it 10. Do/popup Fire7 attack in script
        $showElem = [FIRE, EARTH, STONE, MOUNT,RIVER]
        use element_grid_tutor
        imagebutton:
            auto "sprite/iElder_%s.png" xpos (x_base) ypos (y_base+150) 
            action [SelectedIf(allyN == 2), SetVariable("allyN",2)]      
            hovered [tt.Action(p_elder.name+" Powers: "+p_elder.txt[1])] 
            hover_sound ClickSound activate_sound HealSound 
        add "sprite/iAngelica_insensitive.png" xpos (x_base) ypos (y_base) 
        
        
    elif learn_step == 10:          # learn_step 11: Turn off Elder, Turn on Angelic Harvest. Next text says click on Harvest, then Heal. Heal action makes it 11, Do/popup Harvest5, explain result.
        $showElem = [FIRE, HARVEST, SWAMP]
        use element_grid_tutor
        imagebutton:
            auto "sprite/iAngelica_%s.png" xpos (x_base) ypos (y_base) 
            action [SelectedIf(allyN == 1), SetVariable("allyN",1)]     
            hovered [tt.Action(p_angelica.name+" Powers: "+p_angelica.txt[1])] 
            hover_sound ClickSound activate_sound HealSound 
        add "sprite/iElder_idle.png" xpos (x_base) ypos (y_base+150)

    # learn_step 5: Show Angelica and Elder, they look alive but are just images
    # learn_step 6: Ask to hover angelica to see powers tooltip. Hover makes it 7. Click still inactive
    # learn_step 7: Explain powers, ask to click on Angelica.  Click makes it 8
    # learn_step 8: Show her three elements with element tooltips active. Ask to click on Fire, that makes it 9.
    # learn_step 9: Show Fire tooltip. Ask to click Fight, that makes it 10. Do/popup Fire7 attack in script
    # learn_step 10: Explain what that did. Turn off Angelica, explain that she's spent. Turn on Elder. 
    # Ask to do fire Boost, only allow that. Doing makes it 11, Do/popup FireBoost5. Note that Elder is not as strong in Fire. 
    # learn_step 11: Turn off Elder, Turn on Angelic Harvest. Next text says click on Harvest, then Heal. Heal action makes it 11, Do/popup Harvest5, explain result.

screen element_grid_tutor: # ■██▓▒░ BATTLEGRID_player screen ░▒▓████████████████████████████████████■
    $ xe_base = 500             #Base position of element grid, also used in action tooltip
    $ ye_base =150
    default tte = Tooltip("")
    if tte.value != "":                          # Plant Power Ratings Tooltip: Only show the tooltip frame if it isn't empty
        frame:
            pos (300,0)
            has vbox: 
                text tte.value 
         
    if ListHas(HARVEST,showElem):
        imagebutton auto "gui/iHarvest_%s.png" xpos (xe_base+100) ypos (ye_base+100) action [SetVariable("elemChoice",HARVEST), 
            SetVariable("xpos_tt",xe_base+200), SetVariable("ypos_tt",ye_base+100),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Harvest is nourishing or a tonic\nIncreases Vitality") hover_sound ClickSound activate_sound HealSound     
    if ListHas(FIRE,showElem):                                                         # Element chosen, then choose FIGHT, BOOST or NOTHING as action in Tooltip ((xtt=xe_base-200),(ytt=ye_base))
        imagebutton auto "gui/iFire_%s.png" xpos (xe_base) ypos (ye_base) action [SetVariable("elemChoice",FIRE), #SetVariable("learn_step",8),
            SetVariable("xpos_tt",xe_base-200), SetVariable("ypos_tt",ye_base),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Fire is warming & stimulating\nCounters Earth (cold stagnant) conditions") hover_sound ClickSound activate_sound HealSound
    if ListHas(EARTH,showElem):                                                     
        imagebutton auto "gui/iEarth_%s.png" xpos (xe_base) ypos (ye_base+100) action [SetVariable("elemChoice",EARTH), 
            SetVariable("xpos_tt",xe_base-200), SetVariable("ypos_tt",ye_base+100),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Earth is cooling\nCounters Fire (overheated) conditions") hover_sound ClickSound activate_sound HealSound 
    if ListHas(STORM,showElem):
        imagebutton auto "gui/iStorm_%s.png" xpos (xe_base+100) ypos (ye_base) action [SetVariable("elemChoice",STORM), 
            SetVariable("xpos_tt",xe_base+200), SetVariable("ypos_tt",ye_base),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Storm is cleansing\nCounters Swamp (stagnant, rotting & toxic) conditions") hover_sound ClickSound activate_sound HealSound 
    if ListHas(AIR,showElem):
        imagebutton auto "gui/iAir_%s.png" xpos (xe_base+200) ypos (ye_base) action [SetVariable("elemChoice",AIR), 
            SetVariable("xpos_tt",xe_base+300), SetVariable("ypos_tt",ye_base),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Air is drying & toning\nCounters River conditions") hover_sound ClickSound activate_sound HealSound 
    if ListHas(RIVER,showElem):
        imagebutton auto "gui/iRiver_%s.png" xpos (xe_base+200) ypos (ye_base+100) action [SetVariable("elemChoice",RIVER), 
            SetVariable("xpos_tt",xe_base+300), SetVariable("ypos_tt",ye_base+100),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("River is moistening (water)\nCounters Air (dry) conditions") hover_sound ClickSound activate_sound HealSound 
    if ListHas(STONE,showElem):         
        imagebutton auto "gui/iStone_%s.png" xpos (xe_base) ypos (ye_base+200) action [SetVariable("elemChoice",STONE), 
            SetVariable("xpos_tt",xe_base-200), SetVariable("ypos_tt",ye_base+200),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Stone is slowing (sedative)\nCounters Fire (overstimulated) conditions") hover_sound ClickSound activate_sound HealSound 
    if ListHas(MOUNT,showElem):
        imagebutton auto "gui/iMount_%s.png" xpos (xe_base+100) ypos (ye_base+200) action [SetVariable("elemChoice",MOUNT), 
            SetVariable("xpos_tt",xe_base+200), SetVariable("ypos_tt",ye_base+200),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Mountain is relaxing\nCounters Storm (stress & spasm) conditions") hover_sound ClickSound activate_sound HealSound 
    if ListHas(SWAMP,showElem):
        imagebutton auto "gui/iSwamp_%s.png" xpos (xe_base+200) ypos (ye_base+200) action [SetVariable("elemChoice",SWAMP), 
            SetVariable("xpos_tt",xe_base+300), SetVariable("ypos_tt",ye_base+200),
            ShowTransient('tooltip_action_tutor')] hovered tte.Action("Swamp is moistening (oily)\nCounters Air (dry) conditions") hover_sound ClickSound activate_sound HealSound 
           
        