﻿#init:   # Define Renpy actors and icons

image arrowL = "gui/arrowL.png"
image arrowR = "gui/arrowR.png"
image arrowU = "gui/arrowU.png"
image arrowD = "gui/arrowD.png"
image sickE : 
    "sprite/sprite_sickearth.png" 
    xcenter 50 ycenter 50
image sickF = "sprite/sprite_sickfire.png"
image sickW = "sprite/sprite_sickriver.png"
image iLungs= "gui/iLungs.png"
image clickany = "gui/ClickAnywhere.png"
image goddess = "sprite/GoddessOutline.png"
image helgar sick = "sprite/Helgar1.png"
image helgar cured = "sprite/Helgar2.png"
image helgar dead = "sprite/Helgar3.png"
image bg battle= "BattleSystem.jpg"
image bg BlueDream = "gui/bg_BlueDream.jpg"
image bg intro1 = "gui/HWintroscreen.jpg"
image bg intro2 = "gui/HWintroscreen2.jpg"
image bg helpscreen = "gui/bg_HWhelpscreen.jpg"
image blood FULL = "gui/HWbg_blood_FULL.png"
image blood BL   = "gui/HWbg_blood_BL.png"
image blood BR   = "gui/HWbg_blood_BR.png"
image blood TR   = "gui/HWbg_blood_TR.png"
image bg CloudDream: 
    "gui/BgCD01.jpg"
    0.5
    "gui/BgCD02.jpg"
    0.5
    "gui/BgCD03.jpg"
    0.5
    "gui/BgCD04.jpg"
    0.5
    "gui/BgCD05.jpg"
    0.5
    "gui/BgCD06.jpg"
    0.5
    repeat
            #$ aa =  Plant("Angelica")  # Plant class constructor, optional second argument to set sickPart
            #$ sn = Plant ("Elder")
$
$ diseaseNum = 0

# Declare characters used by this game.
define q = Character('???:', color="#c8ffc8")
define e = Character('Eir:', color="#c8ffc8")
define z = Character(None, kind=nvl)            #Novel mode scrolls off at the bottom. Used as log during battles. 


init python: # ■██▓▒░ GLOBAL VARIABLES ░▒▓████████████████████████████████████■ INIT PYTHON
    random.seed()               # initialize random based on clock
    # Intitialize flags for screens
    config.developer = True     # Super useful! SHIFT-R to reload when this is true, for testing without using launcher each time.
    #config.automatic_images = True #automatically defines images by stripping the extension and using separators. "bg_blue.jpg" becomes "image bg blue"
    battlegrid_on = False          # Variable to conditionally display player buttons screen, on player's turn. 
    sickgrid_on = True          # Variable to conditionally display player buttons screen, on player's turn. 
    statsgrid_on = False 
    diseaseNum = 0              # Disease counter, to change diseases each fight
    step = 0
    effect = False
    msg_pos =  (350,50)         #pos - tuple of (position, position) used by notification message transforms (such as blinkie)
    msg_align = (0.5, 0.5)      #align - tuple of (float, float) used by notification message transforms (such as blinkie)
    learn_step = 0
    xpos_tt = 0                 # for position of tooltip. Sadly have to make this a global variable until I figure out *args to screen
    ypos_tt = 0
    Rounds = 0                  # Counter for rounds of combat
    ClickSound = "mus/click.wav"
    HealSound = "mus/alert.wav"

    # Initialize class variables
    noPowers = Plant("Placebo")             #Start with an ally that has no powers
    allPowers = Plant("Panacea")
    p_angelica = Plant("Angelica")
    p_elder = Plant("Elder")
    p_elecampane = Plant("Elecampane")
    team_list = [p_angelica, p_elder, p_elecampane]  # List of all plants
    team_active = [0,0]
    recruit = noPowers.name
                                                # BATTLE Variables
    ally = noPowers
    client = Villager("Villager")
    sick = Disease(element=EARTH)
    showElem = [EARTH,FIRE, RIVER, STORM, AIR, HARVEST,STONE, MOUNT, SWAMP]    # List of element buttons to display
    angelica_active = True              # REDUNDANT ####################
    elder_active = True                 # REDUNDANT ##################
    
    
    
                                                # TEAM SELECT variables
    slot_unlocked = [True,True,False]           # Only the first two slots are open at first 
    Ateam = [noPowers,p_angelica,p_elder,noPowers]       # Active Team : Start with empty roster, showing the None icons
    Pteam = [noPowers,p_angelica, p_elder, p_elecampane] # Potential Team / Plant Team: List of all plants in the game
    clear_Ateam = False                         # Set all action flags to False
    add_Ateam = False
    start_battle = False
    
    # Constants to used with variable playerAction

    SKIP = 6 
    FIGHT = 1
    BOOST = 2
    HEAL = 3
    RETREAT = 4
    NOTHING = 5
    playerAction = 0
    elemChoice = 0              # set to one of the elemental constants (int) such as EARTH, FIRE, for functions. 
    sickElement = ""
    allyN = 0                      # index for current plant ally of Ateam[]
    
#    renpy.watch(battlegrid_on)     # Displays that variable's value in the upper left corner for debugging




#============================================================================================== 
# ■██▓▒░ START LABEL ░▒▓█████████████████████████████████████████████████████████████████████■
#==============================================================================================


                                                                        # ■██▓▒░ Start Label, setup ░▒▓█████████■
label start: 
    $ wins = 0 #number of battles won, unlocks allies and team slots
    $ firsttime=0
    
    play music "mus/HWmusic.mp3" fadeout 1.0 fadein 1.0
    window hide
    show screen restartGame
    $Ateam[0] = noPowers
    $Ateam[1] = p_angelica
    $Ateam[2] = p_elder
    $Ateam[3] = noPowers
    $ maxteam =2                        # only on first battle for player turn
    $ organ = LUNGS
    
    #jump battle_menu
    #jump team_selector
    
    show bg helpscreen  with dissolve 
    pause
    show bg intro1 with dissolve 
    pause
    show bg intro2 with dissolve 
    pause
    show bg CloudDream with dissolve
    



    #jump battle_prep
    #$ Ateam = team_selection(Ateam,Pteam)                          ###################################################### MOVE
    #jump team_selector
    
    call screen disclaimer
    jump goddess_intro
                                                                        # ■██▓▒░ Actual start of game ░▒▓█████████■
label goddess_intro:
    window show
    $ sick = Disease(element=EARTH)     # CHECK THIS TO PUT IN BEST PLACE
    $ client = Villager("Villager")     #Just making sure they're defined before usage, and reset by restarting the game

    show goddess with dissolve    
    q "Greetings novice, you have just enterered the spirit world to learn about healing. 
       \nIt can be a confusing place, and so I have chosen be your guide.\n ... (Click to continue) ..."

    e "My name is Eir, best among healers in Asgard. Perhaps you've heard of me? 
       \nWe Goddesses of Frigga's court are no longer as well known as we once were...\n ... (Click to continue) ..."
       
    e "I will show you the disease you are fighting, and the villager you are helping. Would you prefer to...\n ... (Click to continue) ..."
    
    menu: 
        "Play the tutorial":
            hide goddess with dissolve
            jump tutorial                                                       # ■██▓▒░ Tutorial
        "Go directly into spirit battle":
            hide goddess with dissolve             #### TEAM SELECTION HERE
            jump battle_prep                                                           # ■██▓▒░ PREP for battle

label battle_menu:
    show goddess with dissolve    
    menu: 
        "Play the tutorial":
            hide goddess with dissolve
            jump tutorial                                                       # ■██▓▒░ Tutorial
        "Choose your team of plant allies":
            hide goddess with dissolve
            jump team_selector                                                  # ■██▓▒░ Team selector    
        "Go directly into spirit battle":
            hide goddess with dissolve
            jump battle_prep                                                           # ■██▓▒░ PREP for battle     #### TEAM SELECTION HERE
        "Exit game":
            hide goddess with dissolve
            return                                                              # ■██▓▒░ Exit game






#============================================================================================== 
# ■██▓▒░ Battle section ░▒▓█████████████████████████████████████████████████████████████████████■
#==============================================================================================


                                                                        # ■██▓▒░ PREP ░▒▓█████████■
label battle_prep:
    play music "mus/HB2s.wav" fadeout 1.0 fadein 1.0
    $ Rounds = 0                  # Counter for rounds of combat

    show bg BlueDream with dissolve
    show helgar cured with dissolve
    $ step =1    # for screen Turn_frame, Player turn, hides sickgrid, turns on battlegrid
    show screen disease_stats
    show screen villager_stats
    show screen Turn_frame
    show sickE at sneaky_disease1   ################## 

 #   $ temp = float(client.earthImbalance())
 #   "imbalance: [temp:.2] percent"
    $ sick.spread =500  
    $ client.earth=100
    $ client.fire=-100
    $ client.water=0
    $ client.air =0
    $ client.vitality=500
    show screen bloodshot   #findme
    window hide                         # add it again when in NVL mode for log


    "FIGHT! Remember, only Fire and Harvest will be useful in this battle. Click on the plant ally, then the element to use, then the action. Click to start\n(You may also use the numeric keypad to select elements, the  / , * and - keys above for actions menu choices, or arrow keys and Enter)."
    show helgar sick at transparent25
                                                                        # ■██▓▒░ FIGHT: DISEASE TURN ░▒▓█████████■
label fight:
    $ Ateam[1].active=False
    $ Ateam[2].active=False
    $ Ateam[3].active=False
    show screen show_team           # Plants are inactive, but still need to show during disease turn
    $ wait_for_popupR()             # wait for popupR to finish displaying changes before disease turn. Max 5 seconds.


    $ step =1
    $ Rounds += 1                  # Counter for rounds of combat
    
    # Treat disease as plant with power of 10 in Earth & Harvest (Virulence). Same mechanics. 
          #  goodimmunity = random.randrange(Immunity+1)  # immune response is 0 up to Immunity (if 3, then 0 to 3)
    $ dice = random.randrange(5,10)  #randome number from 1 to 5
    $ sick.effect = client.earthImbalance()
    $ hit = int(dice * 10 * (float(sick.effect)/100))
    if sick.spread > 500:                                               #if spread very high, time to weaken the host. 
        show sickE at sneaky_disease_attack               #███ SICK ON
        $ client.vitalStat(-hit)
        show screen clientstat_change                                                           #███ statdrop
    elif client.vitality < 100:                                         # They're almost dead, finish them off
        show sickE at sneaky_disease_attack               #███ SICK ON
        $ client.vitalStat(-hit)
        show screen clientstat_change                                                           #███ statdrop        
    elif sick.spread > client.vitality:                                 #if spread is high and client is weak, keep spreading so we don't kill the host
        show sickE at sneaky_disease_spread               #███ SICK ON
        $ sick.spreadStat(hit)
        show screen sickstat_change                                                             #███ statdrop
    else:                                                               #If spread is low and patient is strong, weaken them so we can spread more. 
        show sickE at sneaky_disease_attack               #███ SICK ON
        $ client.vitalStat(-hit)
        show screen clientstat_change                                                           #███ statdrop

    $ wait_for_popupL()             # wait for popupL to finish displaying changes before player turn. Max 5 seconds.
    $ step =5                           # Sets turn to player
    hide screen show_team               # Hide the team screen before turning plants active. They'll show up again as soon as the call screen is done. 
    
    #$ ally = Ateam[1]
    #$ angelica_active = True
    #$ elder_active = True
    #$ ally = p_angelica
    
    jump multiplayer_turn

# def One_Plant_Active (Ateam, maxteam) Returns true if at least one plant is still active, having not done an action yet. maxteam is current nb of plants on Ateam
# change selection screen so Ateam[0] = noPowers. Tooltip will show elemental powers of noPowers if Ateam[count].active is false. 
    
# def Deactivate (Ateam, n, maxteam) #Sets Ateam[n].active = False, 

# The loop will start with a call screen, on return process the action of Ateam[n] (or ally), set it to inactive, increment n. 
# If no allies are active, go to Disease's turn. (There will be a transitional state to return ally to lineup once it animates forward to attack)

                                                                        # ■██▓▒░ PLAYER TURN ░▒▓█████████■    
label multiplayer_turn:                         # New loop allowing alternat team roster. 
    show screen element_grid            # Show the element grid
    $ Ateam[1].active=True              # Activate Allies
    $ Ateam[2].active=True
    #$ Ateam[3].active=True
    $ allyN = 1                         # Start with first ally

    # HEAL FIGHT, BOOST, NOTHING
    
    while one_plant_active(Ateam, maxteam) and step > 4:   # (step is used in skip turn)  # Returns true if at least one plant of Ateam[].active == True. Exits to Disease turn if False
        #"Currently on Ally [allyN]"
        call screen show_team                   # Calls interactive screen. Returns when button is pressed with 
                                                # variables: elemChoice, playerAction, allyN (int index for Ateam[]) 
                                                
        $ dice = random.randrange(5,10)         # random damage multiplier from 5 to 10 (remember to seed)
        

        if playerAction == HEAL:
            if True:                             # can_be_healed (client):  #Later there will be diseases that prevent healing
                $ result = dice * Ateam[allyN].elem[organ][HARVEST]
                $ client.vitalStat(result)                                      # Add (rating*10) to villager Vitality
                $ popupR (Ateam[allyN].name," to Vitality",result,"+")
            else:
                hide screen element_grid                                        # Hide grid first, otherwise player can use another element under the popup.
                call screen mocking # $ popupR (ally.name," healing has no effect")
                show screen element_grid                                        # Show again after, or player will have no way to continue         
        elif playerAction == FIGHT:
            if vulnerable_to (sick, elemChoice):
                $ result = -(dice * Ateam[allyN].elem[organ][elemChoice])
                $ sick.spreadStat(result)                                       # Subtract (rating*10) to disease Spread
                $ popupR (Ateam[allyN].name," disease Spread ",result)
            else:
                hide screen element_grid                                        # Hide grid first, otherwise player can use another element under the popup.
                call screen mocking # $ popupR (ally.name," attack has no effect")
                show screen element_grid                                        # Show again after, or player will have no way to continue                 
        elif playerAction == BOOST:
            $ result = Ateam[allyN].elem[organ][elemChoice]
            $ elemChoice = simplify_elem(elemChoice)        #Simplifies Boosts down to the 4 elements + STORM. !!! add Stress/Toxin mechanics later
            if elemChoice == FIRE:
                $ client.fireStat(+result)
            elif elemChoice == EARTH:
                $ client.earthStat(+result)            
            elif elemChoice == AIR:
                $ client.airStat(+result)                
            elif elemChoice == WATER:
                $ client.waterStat(+result)                
                
            if vulnerable_to (sick, elemChoice):        # If sickness vulnerable to that element
                $ sick.effect = client.earthImbalance()   # SPECIFIC TO SAMPLE DISEASE ONLY, GENERALIZE LATER
                $ popupR (Ateam[allyN].name, (getElemName(elemChoice)+"\nDisease effect DOWN to "+str(sick.effect)+"%"), result, "+") #
            elif elemChoice == sick.element:               # If player boosts element that the disease needs to spread
                $ sick.effect = client.earthImbalance()   # SPECIFIC TO SAMPLE DISEASE ONLY, GENERALIZE LATER
                $ popupR (Ateam[allyN].name, (getElemName(elemChoice)+"\nYou've made the disease stronger!\nDisease effect UP to "+str(sick.effect)+"%"), result, "+")
            else:                                       # This choice makes no difference to the disease
                $ popupR (Ateam[allyN].name,(getElemName(elemChoice)+"\n(No effect on disease)"),result, "+")
                        #call screen mocking # $ popupR (ally.name," boost has no effect on disease",0,elemChoice)
                
        elif playerAction == SKIP:                                              # Player skips rest of their turn
            # Fight will set all plants to inactive. Do I need anything else here?
            $ playerAction = 0
            $ elemChoice = 0
            hide screen element_grid                                            # Hide the action grid during disease turn
            jump fight                                                          # Go directly to Disease turn


        $ allyN = deactivateP(allyN, Ateam)   # Sets current active to false. Returns index of next active plant, 0 if none available      
        $ playerAction = 0
        $ elemChoice = 0
        
        #"allyN:[allyN]  elemChoice:[elemChoice] playerAction:[playerAction]" # +str(Ateam[allyN].active)+
        
        if sick.spread < 1:                                     # Player wins, disease is defeated             
            jump victory
        if client.vitality <1:                                  # Disease wins, client is dead 
            jump death
                                                                # Cleanup before ending player turn
    $ playerAction = 0
    $ elemChoice = 0
    #"Wait"
    hide screen element_grid                                    # Hide element action grid during Disease turn
    jump fight                                                  # No one wins yet. Go to disease turn. 
        

    
                                                                        # ■██▓▒░ OLD VERSION: Player turn░▒▓█████████■
    
    

                                                                        # ■██▓▒░ VICTORY ░▒▓█████████■
label victory:
    hide screen bloodshot
    play music "mus/HWmusic.mp3" fadeout 1.0 fadein 1.0
    call screen bigMessage("You win! Disease defeated in "+str(Rounds)+ " rounds.")
    hide screen show_team
    hide screen element_grid 
    hide sickE with dissolve
    show helgar cured
    e "Well done, novice, you've defeated the disease with the help of your plant spirit friends."
    hide helgar with dissolve
    show goddess with dissolve  
    if wins == 0:
        e "I am looking for a few mortals to train in advanced healing arts, and you show promise."
        e "I will consider your performance, and should you seek me out, seriously consider your potential to become an Herb Witch."
        $wins = 1
        show screen achievement("[wins] victory: Elecampane unlocked!")
        $ p_elecampane.active = True
        $ p_elecampane.unlocked = True
        e "With this victory, Elecampane now finds you worthy. (NEW PLANT ALLY UNLOCKED! )"
        e "If you wish, you may click to try this battle again, choosing two of your three allies, or Escape to return to your world."        
        "UNLOCKED: You can now access the Team Roster Selection screen from the menu!"
        jump battle_menu
    if wins > 0 :
        $wins = wins +1
        show screen achievement("[wins] victories: Well done !")

        e "You show real promise! Your spiritual power has increased further."
        e "If you wish, you may click to try this battle again, choosing two of your three allies, or Escape to return to your world."  
    jump battle_menu

                                                                        # ■██▓▒░ DEATH ░▒▓█████████■
label death:
    play music "mus/HWmusic.mp3" fadeout 1.0 fadein 1.0

    call screen bigMessage("The villager has died!") #\nafter "+str(Rounds/3.0)+ " days of battle.")
    hide screen show_team
    hide screen element_grid
    show helgar dead with dissolve
    e "I am... very disappointed in you, mortal. I put some of my best healing spirits at your command, and you let the villager die... of a chest cold no less!"
    show goddess with dissolve   
    e "I was looking for a few mortals to train in advanced healing arts. Sadly, you do not seem to have the slightest talent for healing."
    e "Perhaps I expected too much of you, and should not have left a life in your hands. The weight of that foolishness is mine to bear."
    e "Still, I saw a spark of something in you that resembled my own. I will give you one more chance to prove you have the healing talent. Do not fail again."
    e "If you really deeply want to become an Herb Witch, you may click to try this battle again, and perhaps save the villager. If you instead use the Escape key, you will be to returned to your world and we shall not speak again."
    hide screen bloodshot
    jump battle_menu    


                                                                        # ■██▓▒░ Disclaimer refusal ░▒▓█████████■
label negotiate:
    window show 
    "Well, you and I have a problem. We could send Guido over to threaten you, but that would be ethnic stereotyping and totally uncool. So are we cool with the disclaimer?\n(use PageUp or MouseWheelUp to go back and make a different choice)"
    menu: 
        "I'm cool, I won't make you resort to uncool actions.\nI agree to the disclaimer":
            jump agreed1
        "Not cool! I deeply resent the stereotype.":
            pass
    "How about if I give you cake? Will you agree to the disclaimer?"
    menu: 
        "Sure! I love cake!":
            jump tricked
        "I think you're trying to trick me...":
            pass
    "Would I do that to you?"
    menu: 
        "Nevermind, I agree. Let me play this game":
            jump agreed1
        "I will never agree!":
            pass
    "Okay, then I'll have to end the game... "
    return

label tricked: 
    "The cake was a lie... sorry about that. But you agreed, so we can continue."

label agreed1:
    "Excellent! Let the game begin..."
    jump goddess_intro
    
    
label tutorial:
    play music "mus/HWmusic.mp3" fadeout 1.0 fadein 1.0
    show bg BlueDream with dissolve
    $ learn_step = 0
    
    # Disease stats screen tutorial ===============================================================
    show screen disease_stats_tutor
    e "We are now in the place between worlds where disease spirits can attack the living. I will show you what to do.\n ... (Click to continue) ..."
    show helgar cured with dissolve

    #jump midtutorial ######################################  TEMP CODE REMOVE ##############################
    $Ateam[1] = p_angelica  #This is so the statdrops show the correct name now
    $Ateam[2] = p_elder
    
    e "By the way, meet Helgar. This is the villager who'll be helping us."
    e "It's good that you've chosen my tutorial, novice, because you'll soon be going up against a disease.\n ... (Click to continue) ..."
    e "If you do well in that battle, I will consider training you to be an Herb Witch. Thus we shall discover whether you have any talent for this!\n ... (Click to continue) ..."
    e "Now, look up to the left. You'll see how far the disease has spread through Helgar's body. \nCurrently it's at zero, and he's feeling great.\n ... (Click to continue) ..."
    $ msg_pos=(250,5) # position for the arrow's blinkie animation
    show arrowL at blinkie    #███ ARROW ON
    while learn_step < 5: 
        e "{fast}To learn more about this disease, point over the disease information \n(then click to continue)."
    hide arrowL                 #███ ARROW off
    $ msg_pos=(250,35) # position for the arrow's blinkie animation
    show arrowL at blinkie      #███ ARROW ON
    e "Very Good! You can see this disease's type. It affects the lungs with the elemental power of Earth. Earth is cold, congested, and its opposite is Fire.
     (If the disease box shrinks, just point there to reveal it again.)\n ... (Click to continue) ..."
    hide arrowL                 #███ ARROW off
    $ msg_pos=(250,130) # position for the arrow's blinkie animation
    show arrowL at blinkie      #███ ARROW ON
    e "In Abilities: Notice that its power is Earth, level 10. That's a pretty nasty chest cold Helgar is about to get! "
    show helgar sick

    e "Each turn it can do up to 10 times its power level in damage, so you see its Strike is 50 to 100."
    e "It attacks with Earth to reduces your villager's Vitality, making them weak and tired.\nIf their Vitality drops to zero, they die.\n ... (Click to continue) ..." 
    hide arrowL                 #███ ARROW off
    e "Try to avoid that. Dead customers don't pay and don't come back, except maybe to haunt you.
     {p}Since you're becoming an Herb Witch, ghosts of dead customers could be a real problem. \nTry to keep them alive!\n ... (Click to continue) ..."
    e "By the way, use PageUp or Mouse Wheel Up if you need to go back and read previous messages. Try that now.\n ... (Click to continue) ..."
    show sickE at sneaky_disease1 with hpunch           #███ SICK ON
    e "What's that?{p=3.0}Ah, crap, a disease just showed up.{p=2.0}It's an Earth disease too, I guess it heard us talking about it."
    $ msg_pos=(250,157) # position for the arrow's blinkie animation
    #show arrowL at blinkie      #███ ARROW ON
    #e "Just ignore it for now. The next ability is Virulence. That's how fast a disease spreads through the villager's body.\n ... (Click to continue) ..."
    #hide arrowL                 #███ ARROW off
    $ msg_pos=(250,5) # position for the arrow's blinkie animation
    show arrowL at blinkie      #███ ARROW ON
    show sickE at sneaky_disease_spread with hpunch     #███ SICK ON
    $ sick.spreadStat(+50) 
    show screen sickstat_change #at drop_status                                   #███ statdrop
    e "And now it's spreading! Look at that Spread score! This can't be good... we should check up on Helgar's Vitality."
    hide arrowL                 #███ ARROW off
    #$learn_step =6    #This breaks us out of the loop. 
    #show screen element_grid_tutor
    
    # Villager stats screen tutorial ===============================================================
    show screen villager_stats_tutor
    $ msg_pos=(950,5) # position for the arrow's blinkie animation
    show arrowR at blinkie              #███ ARROW ON
    while learn_step < 7:       # This will loop until player reveals the second stats_tutor with a mouseover, making learn_step = 7
        "{fast}Move your mouse pointer to the upper right corner to see how the villager is doing\n(then click to continue)"
    hide arrowR                 #███ ARROW off
    show helgar cured
    e "Excellent! It seems Helgar is doing fine, their Vitality is still at maximum. \nThey don't seem sick at all.{p=5.0}
     \nI don't need to keep telling you to 'Click to Continue,' do I? I'm sure you can figure that out from now on."
    e "Great! I knew you were a quick learner. Now there doesn't seem to be any..."
    show sickE at sneaky_disease_spread                 #███ SICK ON
    $ sick.spreadStat(+50)           
    show screen sickstat_change                                                 #███ statdrop
    e "What's the disease doing? Is it spreading again? And why is the villager still fine?{p=3.0}
     \nOh I see. The disease is incubating! It's spreading inside the body without causing any symptoms... yet!"
    
    #$ msg_pos=(975,45) # position for the arrow's blinkie animation
    #show arrowR at blinkie      #███ ARROW ON
    #e "Let's use this time to finish inspecting our villager. Look at those Stress and Toxins scores."
    #e "They're each at 50, which is normal for these villagers. A normal body is constantly collecting and eliminating stress and toxins."
    #hide arrowR                 #███ ARROW off
    #e "Mountain herbs are relaxants that reduce stress. Storm herbs are antiseptic blood cleansers that reduce toxins. Reducing these scores Buffs up the immune system, though we won't be dealing with that today."
    #e "Think about it. You get stressed, and then you relax. Rarely does anyone fully relax, unless they practice some sort of meditation."
    #e "Think about it. You get stressed, and then you relax. Rarely does anyone fully relax, unless they practice some sort of meditation.
    # {fast} The same is true of toxins. We eat things that aren't good for us, our body produces some, and then we eliminate most of those toxins."
    #e "How? We poop, pee, puke or perspire to get rid of them. But we can never get rid of all the toxins, just keep them at a reasonable level."
    #e "How? We poop, pee, puke or perspire to get rid of them. But we can never get rid of all the toxins, just keep them at a reasonable level.
    #{fast} Accumulating too much stress or toxins makes it harder for our body to fight off infections and other diseases."
    
    show sickE at sneaky_disease_spread                 #███ SICK ON
    $ sick.spreadStat(+50)
    show screen sickstat_change                                                 #███ statdrop
    e "The disease is still spreading without noticeable symptoms. Let's look at the villager's elemental balance now"
    $ msg_pos=(950,95) # position for the arrow's blinkie animation
    show arrowR at blinkie      #███ ARROW ON
    e "Everything looks fine, the elements are balanced at zero. When there's too much Earth, the body becomes cold and sluggish."
    e "Everything looks fine, the elements are balanced at zero. When there's too much Earth, the body becomes cold and sluggish.
     {fast} When there's too much fire, it becomes hot and over-stimulated, which can lead to exhaustion."
    hide arrowR                 #███ ARROW off
    e "Now let's look at...{nw}"
    show sickE at sneaky_disease_boost               #███ SICK ON
    e "Now let's look at...{fast} what the...? What is it doing now?"
    $ client.earthStat(+25)
    $sick.effect = client.earthImbalance()
                                    #BUG REMOVED, no need for this$ client.actiontext = "Villager's Earth increases by 25,\n Fire decreases by 25"
    show screen clientstat_change                                               #███ statdrop
    $ msg_pos=(250,35) # position for the arrow's blinkie animation
    show arrowL at blinkie      #███ ARROW ON
    e "Ah, it's boosting the villager's Earth. Look where I'm pointing. Effectiveness has gone up to 25\%."
    e "It's creating the right climate for its attacks to be effective. In this case, cold and stagnant Earth. "

    show screen full_villager_stats
    show screen full_disease_stats
    
    hide screen disease_stats_tutor             #tutor stats screens off, now onto the real screens, which both drop at the same time
    hide screen villager_stats_tutor
    
    #show sickE at sneaky_disease_boost               #███ SICK ON
    $ client.earthStat(+25)
    $sick.effect = client.earthImbalance()
    show screen clientstat_change                                               #███ statdrop
    e "IMPORTANT: To defeat this disease, you'll need to fight its spread with Fire because its strenth is based on the lungs being cold enough."
    e "So if you boost the element of Fire, it will reduce how much damage the disease can do, and how much it can spread."
    $ msg_pos=(950,100) # position for the arrow's blinkie animation
    show arrowR at blinkie      #███ ARROW ON
    e "Look at the villager's Earth and Fire. Fire is going down, and Earth is going up."
    show sickE at sneaky_disease_boost               #███ SICK ON
    $ client.earthStat(+25)
    $sick.effect = client.earthImbalance()
    show screen clientstat_change                                               #███ statdrop
    e "It's almost done incubating and will start doing damage soon."
    show helgar sick
    show sickE at sneaky_disease_boost               #███ SICK ON
    $ client.earthStat(+25)
    $sick.effect = client.earthImbalance()
    show screen clientstat_change                                               #███ statdrop
    e "That's it, 100\% effectiveness. Now it starts doing damage. Clients don't know they're sick until they reach this point, so diseases will always be this way when you start treating them."

                                         #███ statdrop
    hide arrowL                 #███ ARROW off
    hide arrowR                 #███ ARROW off
    show sickE at sneaky_disease_attack               #███ SICK ON
    $ client.vitalStat(-50)
    show screen clientstat_change  
    
    
label midtutorial:
    hide screen full_villager_stats
    hide screen full_disease_stats
    
    show screen disease_stats             #tutor stats screens off, now onto the real screens, which both drop at the same time
    show screen villager_stats    

    show helgar sick at transparent75   
    e "The villager is losing vitality. I should introduce you to your allies."

    # learn_step 5: Show Angelica and Elder, they look alive but are just images
    $ learn_step =5
    show screen battle_tutor
    e "These are Angelica and Elder"

    # learn_step 6: Ask to hover angelica to see powers tooltip. Hover makes it 7. Click still inactive
    $ learn_step =6
    while learn_step == 6:       # This will loop until player mouseovers Angelica, making learn_step = 6
        e "{fast}They each have different powers. Put your pointer over Angelica.{fast}{nw}"

    # learn_step 7: Explain powers, ask to click on Angelica.  Click makes it 8
    while learn_step ==7:
        e "{fast}By hovering over an active plant, you can see her elemental ratings. Angelica has Fire level 9, which means she she has a maximum Strike of 90 with Fire. Now click on Angelica{fast}{nw}"
    show helgar sick at transparent25  

    while learn_step == 8:
        e "Angelica has three elements but we need Fire to defeat Earth. Click on Fire, then choose Fire Attack to reduce the Spread of the disease."
    $ sick.spreadStat(-90)
    show screen sickstat_change2                                                #███ statdrop  
        
    while learn_step == 9:
        e "Well done! Disease Spread went down by 90 points. Let's press the attack! Unfortunately, allies can only act once per turn, then go gray while they rest. It's Elder's turn to act. Click the Fire icon, then choose Boost Fire to reduce disease Effectiveness."       
    $ client.earthStat(-5)
    $sick.effect = client.earthImbalance()
    $ sick.actiontext = "Disease effectiveness down to 95%"   # ##### BAD KLUDGE but works
    show screen sickstat_change3                                                #███ statdrop  
    
    e "Good! Disease Effectiveness went down to 95\%. Elder's Fire is only level 5, so it's not much but it does add up. If you keep making the Climate warmer with Fire, the Earth diseases attacks and spread will get weaker and weaker."        
    while learn_step ==10:
        e "The disease normally gets a turn now, but I've refreshed Angelica for you. Use her Harvest ability to heal Helgar. That will increase their Vitality."
    $ client.vitalStat(40)
    show screen clientstat_change2                                              #███ statdrop     
    e "Look how Helgar's Vitality went up! Well done."
    jump tutorialend

        
    

    

    # learn_step 5: Show Angelica and Elder, they look alive but are just images
    # learn_step 6: Ask to hover angelica to see powers tooltip. Hover makes it 7. Click still inactive
    # learn_step 7: Explain powers, ask to click on Angelica.  Click makes it 8
    # learn_step 8: Show her three elements with element tooltips active. Ask to click on Fire, that makes it 9.
    # learn_step 9: Show Fire tooltip. Ask to click Fight, that makes it 10. Do/popup Fire7 attack in script
    # learn_step 10: Explain what that did. Turn off Angelica, explain that she's spent. Turn on Elder. 
    # Ask to do fire Boost, only allow that. Doing makes it 11, Do/popup FireBoost5. Note that Elder is not as strong in Fire. 
    # learn_step 11: Turn off Elder, Turn on Angelic Harvest. Next text says click on Harvest, then Heal. Heal action makes it 11, Do/popup Harvest5, explain result.
    



    # hide screen element_grid_tutor
    # show screen element_grid
    #while learn_step < 9: 
    e "Now Click on Fire Attack to reduce the spread of the disease."
    $ sick.spreadStat(-90)
    show screen sickstat_change2                                                #███ statdrop
    
    
    
    
    e "When spread reachers zero, the disease is defeated and you win! Spread is what the disease has instead of vitality."
    $ angelica_active = False
    $ elder_active = True
    $showElem = [MOUNT,EARTH, FIRE,RIVER, STONE]
    #while learn_step <10:
    e "{fast}You can only use her once every turn, so after her action, she normally goes grey. Click to choose Elder now, then use her Fire to Boost Fire. This will weaken the attacks of the disease.{fast}{nw}"
    e "Click on Fire, then Boost"
    $ client.earthStat(-5)
    $sick.effect = client.earthImbalance()
    e "When you Boost Fire, it weakens the disease's ability to spread and cause damage. Effectiveness drops."
    $ angelica_active = True
    $ elder_active = False
    $showElem = [HARVEST]
    show helgar sick at transparent25      
    
    
    show screen show_team_tutor   
    $ learn_step =5
    $ step =5                                                    # FIX THIS ===============================================
    $ angelica_active = True
    $ elder_active = False
    $ ally = p_angelica   
    # learn_step 1:
    e "These are the plant spirits who have agreed to help you, Angelica and Elder."
    #$showElem = [EARTH,FIRE, RIVER, STORM, AIR, HARVEST,STONE, MOUNT, SWAMP]                   # List of element buttons to display
    $showElem = []
    
    $Ateam[0] = noPowers
    $Ateam[1] = p_angelica
    $Ateam[2] = p_elder
    $Ateam[3] = noPowers
    $ maxteam =2                        # only on first battle for player turn
    $ organ = LUNGS
    show screen element_grid_tutor
    $ Rounds = 29

    #while learn_step < 6:       # This will loop until player mouseovers Angelica, making learn_step = 6
    #    e "{fast}They each have different powers. Put your pointer over Angelica.{fast}{nw}"
    while learn_step < 7:
        e "{fast}By hovering over an active plant, you can see her elemental ratings. Angelica has Fire level 9, which means she she has a maxiumum Strike of 90 with Fire. Now click on Angelica{fast}{nw}"
    show helgar sick at transparent25  
    $showElem = [FIRE, HARVEST, SWAMP]
    $ally = p_angelica
    while learn_step < 8:
        e "{fast}When you select a plant, her element power grid appears. She has Fire, Harvest, and Swamp. Only her Fire and Harvest will be useful against an Earth disease. Click on the Fire icon.{fast}{nw}"
    # hide screen element_grid_tutor
    # show screen element_grid
    #while learn_step < 9: 
    e "Now Click on Fire Attack to reduce the spread of the disease."
    $ sick.spreadStat(-90)
    show screen sickstat_change2                                                #███ statdrop
    
    e "When spread reachers zero, the disease is defeated and you win! Spread is what the disease has instead of vitality."
    $ angelica_active = False
    $ elder_active = True
    $showElem = [MOUNT,EARTH, FIRE,RIVER, STONE]
    #while learn_step <10:
    e "{fast}You can only use her once every turn, so after her action, she normally goes grey. Click to choose Elder now, then use her Fire to Boost Fire. This will weaken the attacks of the disease.{fast}{nw}"
    e "Click on Fire, then Boost"
    $ client.earthStat(-5)
    $sick.effect = client.earthImbalance()
    e "When you Boost Fire, it weakens the disease's ability to spread and cause damage. Effectiveness drops."
    $ angelica_active = True
    $ elder_active = False
    $showElem = [HARVEST]
    show helgar sick at transparent25  
    
label tutorialend:
    e "Keep in mind that if the villager's vitality drops to zero, they die."
    e "When a disease's Spread goes to zero, they are defeated" #Use Angelica's Harvest to increase their Vitality." 
    e "Now you know what you need to win a fight... so let's go into a real fight..."
    $ step =0
    hide screen element_grid_tutor
    e "Well done on learning all this!"
    hide screen full_disease_stats            #tutor stats screens off, now onto the real screens, which both drop at the same time
    hide screen full_villager_stats
    hide screen disease_stats             #tutor stats screens off, now onto the real screens, which both drop at the same time
    hide screen villager_stats  
    #hide screen show_team_tutor   
    hide screen battle_tutor
                                    #  window show # ██████████████████████████████ UNCOMMENT THIS
    call screen bigMessage("Ready yourself, the real battle is about to begin.")

    jump battle_prep
    
    
# ■██▓▒░ TEAM SELECTION ░▒▓██████████████████████████████████████████████████████████████████████████████████████■
label team_selector:
    
    #window hide                 # hide the bottom dialog window
    call screen bigMessage("Choose Your Team For This Battle","     Your spiritual power is only sufficient to sustain two\nallies at first.\n", "     Win battles to unlock more slots for your team\nand more allies to choose from.")
    
    "You only have 2 slots on your team to start with." #without this message, the game hangs
    $ slot_unlocked = [True,True,False]         # Only the first two slots are open at first 
    $ Ateam = [noPowers,noPowers,noPowers,noPowers]      # Start with empty roster, showing the None icons
    $ p_angelica.active = True                  # Set each plant to active. Active means they have not yet been added to the roster
    $ p_elder.active = True                     # Though this changes nothing to whether they are locked or not. Put in FUNCTION
    $ p_elecampane.active = True
    $ Pteam = [noPowers,p_angelica, p_elder, p_elecampane] # Potential Team / Plant Team: List of all plants in the game

    $ ally = noPowers                           # Selected ally starts with the dummy plant
    
    $ clear_Ateam = False                       # Set all action flags to False
    $ add_Ateam = False
    $ start_battle = False
    $ overfull = False
    $ answer =""

    #show screen choose_team
    #show screen roster_screen
    #show screen plant_info_screen
    show screen choose_team_roster # The combination of all three into one screen
    
    window show                 # show the bottom dialog window
    "Instructions: \n1) Click on a plant ally on the right,\n2) Click Add on the bottom. Repeat 1 & 2 until your roster is full.\nWhen you're done, click Start Battle.\n ... (Click to continue) ..."
    window hide                 # hide the bottom dialog window

    hide screen choose_team_roster #We were simply displaying it before. After this we'll use CALL so it returns to the event handler after each button. 

label team_selection_loop:              # Check the three flags controlled by roster_screen, act if needed, then loop back here. 
    # Flags set by screen:                      add_Ateam, clear_Ateam, start_battle 
    # Data used but not changed by screen:      allyN (int), ally(class Plant), Ateam (Active team, array of class Plant), Pteam (Potental team, array of class Plant)
    
    call screen choose_team_roster      # Only returns from the 

    #When the player 

    # ■██▓▒░ CLEAR ROSTER ░▒▓████████████████████████████████████■

    if clear_Ateam:
        $ clear_Ateam = teamselect_clear(clear_Ateam, Ateam, Pteam) #Clears all and returns False, clearing the flag in one shot
        $ allyN = 0             # Clear index of currently selected plant
        $ ally = noPowers       # Clear redsquare selection on right side of menu. 

    # ■██▓▒░ ADD to ROSTER ░▒▓████████████████████████████████████■
 
    if (add_Ateam == True):             # Player has clicked on ADD. Add "ally" to the roster, if add_ally has been set to "ally"
        $ overfull = teamselect_add (add_Ateam, Ateam, Pteam, allyN, slot_unlocked) # returns True if trying to add while roster is full
        $ add_Ateam = False             # Clear Add flag after handling event
        $ allyN = 0                     # Clear ally, otherwise clicking add again will add it a second time, even if it's greyed.
        $ ally = noPowers               # Clear selected plant ally on right side of menu. 
        if overfull:                         # Adding when roster is full
            $ overfull = False                      # Clear flag so we don't loop back here
            $ start_battle = roster_full(add_Ateam) # Ask player if they want to battle now or return to selection. Sets start_battle flag to True/False

    # ■██▓▒░ START BATTLE ░▒▓████████████████████████████████████■
    if (start_battle):                                                          # When start_battle becomes true, jump to the battle's prep
        $start_battle = False           # Clear the flag so it doesn't return here if they say no
        hide screen choose_team_roster
        call screen bigChoice("The battle is about to begin!", "Are you ready, novice?") # Give clear status message, click on Continue
        if _return == "y": 
            jump battle_prep
        else:
            jump team_selection_loop 
        
        jump battle_prep                                                               # Go to prep and then battle
    else: 
        #"add_Ateam: [add_Ateam] clear_Ateam: [clear_Ateam] allyN: [allyN]" #pause 3   #$ ui.interact() #                           # (Only loop once per two seconds)  ##CHANGE##
        jump team_selection_loop            # Keep Looping otherwise
    # pause 1

label roster_full_dialog:                      # Dialog called by team_selection_loop when trying to add more to a full roster
        #hide screen choose_team_roster # The combination of all three into one screen

        #hide screen plant_info_screen
        call screen bigChoice("Your roster is full", "Would you like to start the battle now? Click Yes to battle.", "Click No to continue choosing your team (Use the Clear button to select a different team).")
        if _return == "y": 
            jump battle_prep
        else:
            jump team_selection_loop 
       # "M Ateam [Ateam[0].name] [Ateam[1].name] [Ateam[2].name] add_Ateam [add_Ateam]"
       # "M Pteam [Pteam[1].name] [Pteam[2].name] [Pteam[3].name] allyN [allyN]"